/* boss.h */
/* include flies for all the modlues */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef __CYGWIN__
#include <curses.h>
#else
#include <ncurses/ncurses.h>
#endif
#include <math.h>
#include <time.h>
#include <unistd.h>         /* for ftruncate, usleep */

#include "mtwist/mtwist.h"  /* random number generation */
#include "patchlevel.h"
#include "configure.h"
#include "constants.h"
#include "types.h"
#include "pascal.h"
#include "routines.h"
#include "term.h"

#include "debug.h"

// boss.c includes the actual declarations of all the variables,
// everything else just includes the extern stuff

#ifdef __BOSS_C__
#include "values.h"
#include "objects.h"
#else
#include "variables.h"
#endif

#define DRAW_BOLT_DELAY 50
#define DRAW_BALL_DELAY 30

#define PSPELL(xx) (magic_spell[py.misc.pclass][(xx)])
#define PCLASS     (class[py.misc.pclass])
#define PM         (py.misc)
#define PS         (py.stat)
#define PF         (py.flags)


/* END FILE  boss.h */
