/* potions.c */
/*{ Potions for the quaffing }*/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void potion_effects(integer effect, boolean *ident, integer item_val)
{
  integer   i7,i5,i4,nhp;

  //with inventory[item_val]. do;

  switch (effect) {
  case 1  :  
    //with py.stat do
    if (inventory[item_val].tohit > 0) { /*{Increase Strength x (tohit) }*/
      for (i7 = 1; i7 <= inventory[item_val].tohit; i7++) {
	PS.cstr = in_statp(PS.cstr);
	*ident = true;
	if (PS.cstr > PS.str) {
	  PS.str = PS.cstr;
	}
	switch (randint(3)) {
	case 1 : msg_print("Wow!  What bulging muscles!");             break;
	case 2 : msg_print("Damn!  You're getting buff!");             break;
	case 3 : msg_print("I bet you pump iron in your spare time."); break;
	}
      }
    } else if (inventory[item_val].tohit < 0) { /*{Lose Strength}*/
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	*ident = lose_str();
	switch (randint(3)) {
	case 1 : msg_print("Your burden feels heavier.");        break;
	case 2 : msg_print("Your muscles shrivel up.");          break;
	case 3 : msg_print("You resemble a 98 pound weakling."); break;
	}
      }
      prt_strength();
      prt_max_weight();
    }
    break;

  case 2  :  
    if (py.flags.diseased == 0) {
      py.stat.cstr = py.stat.str;
      msg_print("You feel warm all over.");
      prt_strength();
      prt_max_weight();
      *ident = true;
    } else {
      msg_print("Your disease nullifies the potion!");
    }
    break;

  case 3  :  
    //with py.stat do;
    if (inventory[item_val].tohit > 0) { /*{ Inc. Intellegence x (tohit) }*/
      for (i7 = 1; i7 <= inventory[item_val].tohit; i7++) {
	*ident = true;
	PS.cint = in_statp(PS.cint);
	if (PS.cint > py.stat.int_) {
	  py.stat.int_ = PS.cint;
	}
	msg_print("Imagine how it would feel if your brain started growing.");
      }
    } else if (inventory[item_val].tohit < 0) {  /*{Dec. Int}*/
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	/* XXXX this did not actually reduce int, it does now... */
	*ident = lose_int();
	switch (randint(3)) {
	case 1: msg_print("This is your brain on drugs.");
	case 2: msg_print("You acc*identally snort this acidic potion up "
			  "your nose.");
	case 3: msg_print("You hear something rattle in your head.");
	}
      }
    }
    prt_intelligence();
    break;

  case 4  :  
    if (py.flags.diseased == 0) {
      py.stat.cint = py.stat.int_;
      msg_print("Your brain throbs for a moment");
      prt_intelligence();
      *ident = true;
    } else {
      msg_print("Your disease nullifies the potion!");
    }
    break;
    
  case 5  :  
    //with py.stat do;
    if (inventory[item_val].tohit > 0) { /*{Increase Wisdom x (tohit) }*/
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	*ident = true;
	PS.cwis = in_statp(PS.cwis);
	if (PS.cwis > PS.wis) {
	  PS.wis = PS.cwis;
	}
	switch (randint(3)) {
	case 1: msg_print("You suddenly have a profound thought!");      break;
	case 2: msg_print("You feel closer to the Buddah consciousness");break;
	case 3: msg_print("Wisdom becomes you, brave adventurer.");      break;
	}
      }
    } else if (inventory[item_val].tohit < 0) { /*{Dec. Wis}*/
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	*ident = lose_wis();
	msg_print("The Buddah slips from your mind's eye.");
      }
    }
    prt_wisdom();
    break;
    
  case 6  :    
    if (py.flags.diseased == 0) {
      py.stat.cwis = py.stat.wis;
      switch (randint(3)) {
      case 1: msg_print("The Buddah forgives you.");              break;
      case 2: msg_print("You feel the Buddah return to you.");    break;
      case 3: msg_print("You realize how foolish you've been.");  break;
      }
      prt_wisdom();
      *ident = true;
    } else {
      msg_print("Your disease nullifies the potion!");
    }
    break;

  case 7  :  
    //with py.stat do;
    if (inventory[item_val].tohit > 0) { /*{Increase Dex }*/
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	*ident = true;
	PS.cdex = in_statp(PS.cdex);
	if (PS.cdex > PS.dex) {
	  PS.dex = PS.cdex;
	}
	switch (randint(4)) {
	case 1 : msg_print("You grow some new fingers."); break;
	case 2 : msg_print("You feel more limber!");      break;
	case 3 : 
	  if (PS.dex > 17) {
	    msg_print("You are suddenly able to juggle.");
	  } else {
	    msg_print("You feel nearly able to juggle.");
	  }
	  break;
	case 4 :
	  msg_print("You grow another limb.");
	  msg_print("But I'm not sure what to call it.");
	  break;
	}
      }
    } else if (inventory[item_val].tohit < 0) { /*{Dec. Dex}*/  
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	switch (randint(3)) {
	case 1:  msg_print("You feel your joints stiffen.");  break;
	case 2:  msg_print("Butterfingers!");                 break; 
	case 3:  msg_print("Your fingers tie in knots.");     break;
	}
	*ident = lose_dex();
      }
    }
    prt_dexterity();
    break;

  case 8  :    
    if (py.flags.diseased == 0) {
      py.stat.cdex = py.stat.dex;
      msg_print("You feel at ease with your body.");
      prt_dexterity();
      *ident = true;
    } else {
      msg_print("Your disease nullifies the potion!");
    }
    break;

  case 9  :  
    //with py.misc do;
    if (inventory[item_val].tohit > 0) { /*{Increase Con }*/
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	*ident = true;
	py.stat.ccon = in_statp(py.stat.ccon);
	if (py.stat.ccon > py.stat.con) {
	  py.stat.con = py.stat.ccon;
	}
	switch (randint(3)) {
	case 1: msg_print("You feel like you've just inhaled a vial "
			  "of amiyl nitrate."); break;
	case 2: msg_print("You feel _really_ healthy."); break;
	case 3: msg_print("Your constitution just went up."); break;
	}
      }
    } else if (inventory[item_val].tohit < 0) { /*{Decrease Con}*/  
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	*ident = lose_con();
      }
      msg_print("..........");
    }
    prt_constitution();
    break;

  case 10  :  
    if (py.flags.diseased == 0) {
      py.stat.ccon = py.stat.con;
      msg_print("You feel your grip on life strengthen.");
      prt_constitution();
      *ident = true;
    } else {
      msg_print("Your disease nullifies the potion!");
    }
    break;

  case 11  :  
    //with py.stat do
    if (inventory[item_val].tohit > 0) { /*{Increase Charisma x (tohit) }*/
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	*ident = true;
	PS.cchr = in_statp(PS.cchr);
	if (PS.cchr > PS.chr) {
	  PS.chr = PS.cchr;
	}
	switch (randint(3)) {
	case 1 : msg_print("Gee, ain't you cute!");       break;
	case 2 : msg_print("Ooh!  What a face!");         break;
	case 3 : msg_print("Quick!  Where's my camera?"); break;
	}
      }
    } else if (inventory[item_val].tohit < 0) { /*{Decrease Chr}*/  
      for (i7 = 1; i7 <= abs(inventory[item_val].tohit); i7++) {
	*ident = lose_chr();
	msg_print("Bleah!  Sourpuss!");
      }
    }
    prt_charisma();
    break;

  case 12 :  
    if (py.flags.diseased == 0) {
      py.stat.cchr = py.stat.chr;
      msg_print("You feel your looks returning.");
      prt_charisma();
      *ident = true;
    } else {
      msg_print("Your disease nullifies the potion!");
    }
    break;

  /*{Healing}*/
  case 13 :  *ident = hp_player(damroll("2d7"),"a potion.");
    break;

  case 14 :  *ident = hp_player(damroll("4d7"),"a potion.");
    break;

  case 15 :  *ident = hp_player(damroll("6d7"),"a potion.");
    break;

  case 16 :  *ident = hp_player(1000,"a potion.");
    break;

  case 17 : 
    break;

  case 18 : 
    //with py.misc do
    i5 = (PM.exp div 2) + 10;
    if (i5 > 100000) { i5 = 100000; }
    PM.exp += i5;
    msg_print("You feel more experienced.");
    prt_experience();
    *ident = true;
    break;

  case 19 :  
    //with py.flags do
    if (! (py.flags.free_act)) {
      msg_print("Sheesh!  Falling asleep on the job!");
      py.flags.paralysis += randint(4)+4;
      *ident = true;
    }
    break;

  case 20 :  
    //with py.flags do
    msg_print("Your eyelids close and fuse shut!");
    PF.blind += randint(100) + 100;
    *ident = true;
    break;

  case 21 :  
    //with py.flags do
    msg_print("Hey!  This is good stuff!  * Hick! *");
    PF.confused += randint(20) + 12;
    *ident = true;
    break;

  case 22 :
    //with py.flags do
    msg_print("You feel very sick.");
    PF.poisoned += randint(15) + 10;
    *ident = true;
    break;

  case 23 :  
    py.flags.fast += randint(25) + 15;
    *ident = true;
    break;

  case 24 :  
    py.flags.slow += randint(25) + 15;
    *ident = true;
    break;

  case 25 :  *ident = detect_monsters();
    break;

  case 26 :  msg_print("hm.  nothing happened that you can see...");
    break;

  case 27 :  msg_print("hm.  nothing happened that you can see...");
    break;

  case 28 :  msg_print("hm.  nothing happened that you can see...");
    break;

  case 29 :  cure_blindness();
    break;

  case 30 :  cure_confusion();
    break;

  case 31 :  cure_poison();
    break;

  case 32 : /*{Cursed bit- do nothing}*/
    break;

  case 33 :  
    //with py.misc do
    switch (PM.pskill) {
    case 1: case 2: case 7:
      *ident = learn_spell(&redraw);
      if (redraw) { draw_cave(); }
      break;
    case 3: case 4:
      *ident = learn_prayer();
      break;
    case 5: case 6:
      *ident = learn_extra(&redraw);
      if (redraw) { draw_cave(); }
      break;
    }
    break;

  case 34 :  
    switch (randint(5)) {
    case 1 : msg_print("You feel your memories fade."); break;
    case 2 : msg_print("You cannot remember your mother's name."); break;
    case 3 : msg_print("You cannot remember your second-grade "
		       "teacher's name."); break;
    case 4 : msg_print("You cannot remember your own name."); break;
    case 5 : msg_print("You can't remember anyone's name."); break;
    }
    msg_print("");
    i4 = trunc(py.misc.exp/5.0);
    lose_exp(randint(i4)+i4);
    *ident = true;
    break;

  case 35 :  
    //with py.flags do
    PF.poisoned = 0;
    if (PF.food > 150) { PF.food = 150; }
    PF.paralysis = 4;
    msg_print("Does the phrase \"spew chunks\" mean anything to you?");
    *ident = true;
    break;

  case 36 : 
    py.flags.invuln += 50;
    msg_print("Your skin turns into a high tech, very");
    msg_print("hard polymerized laminate material.");
    py.misc.pac = py.misc.pac + 100;
    py.misc.dis_ac = py.misc.dis_ac + 100;
    prt_pac();
    *ident = true;
    break;

  case 37 :
    py.flags.hero += randint(25) + 25;
    *ident = true;
    break;

  case 38 :  
    py.flags.shero += randint(25) + 25;
    *ident = true;
    break;

  case 39 :  *ident = remove_fear();
    break;

  case 40 :  *ident = restore_level();
    break;

  case 41 :  
    //with py.flags do
    PF.resist_heat += randint(10) + 10;
    break;

  case 42 :  
    //with py.flags do
    PF.resist_cold += randint(10) + 10;
    break;

  case 43 :  
    detect_inv2(randint(12)+12);
    break;

  case 44 :  *ident = slow_poison();
    break;

  case 45 :  *ident = cure_poison();
    break;

  case 46 :  
    //with py.misc do
    if (PM.cmana < PM.mana) {
      PM.cmana = PM.mana;
      *ident = true;
      msg_print("Power courses through your veins!");
      prt_mana();
    }
    break;

  case 47 :  
    //with py.flags do
    PF.tim_infra += 100 + randint(100);
    *ident = true;
    msg_print("Your eyes shift into low-frequency mode");
    break;

  case 48 : 
    //with py.misc do
    msg_print("You feel able to withstand more damage.");
    msg_print("Now don't get cocky...");
    nhp = randint(2)*get_hitdie();
    PM.mhp += nhp;
    PM.chp += nhp;
    prt_mhp();
    prt_chp();
    break;

  case 49 :  
    //with py.misc do
    msg_print("You feel more confident.");
    gain_mana(int_adj());
    gain_mana(wis_adj());
    prt_mana();
    break;

  case 50 : 
    //with py.misc do  /*{longevity}*/
    if ((PM.prace == RACE_ALIEN) && (PM.age>120)) {
      i7 = 100;
    } else if (PM.age > 20) {
      i7 = 20;
    } else {
      i7 = 0;
    }
    if (i7 != 0) {
      PM.age -= randint(i7);
      PM.age  = greater(PM.age,16);
      msg_print("You feel much younger.");
    } else {
      msg_print("You feel nothing happen.");
    }
    break;

  default:
    msg_print("The bottle was empty.");
    break;
  }
};
//////////////////////////////////////////////////////////////////////
void quaff()
{
  unsigned   i1;
  integer    i2,i3;
  integer    item_val;
  boolean    redraw,ident;
  obj_set    glug_glug = {75,76};

  reset_flag = true;
  if (inven_ctr > 0) {
    if (find_range(glug_glug,&i2,&i3)) {
      redraw = false;
      if (get_item(&item_val,"Quaff which potion?",&redraw,i2,i3)) {
	//with inventory[item_val]. do;
	if (redraw) { draw_cave(); }
	reset_flag = false;
	i1 = inventory[item_val].flags;
	ident = false;

	for (;i1 > 0;) {
	  i2 = bit_pos(&i1) + 1;
	  if (inventory[item_val].tval == 76) { i2 += 32; }
	  potion_effects(i2, &ident, item_val);
	}

	if (ident) {
	  identify(&inventory[item_val]);
	}

	if (inventory[item_val].flags != 0) {
	  //with py.misc do;
	  PM.exp += (real)inventory[item_val].level/(real)PM.lev + .5;
	  prt_experience();
	}

	add_food(inventory[item_val].p1);
	desc_remain(item_val);
	inven_destroy(item_val);
      } else {
	if (redraw) { draw_cave(); }
      }
    } else {
      msg_print("You are not carrying any potions.");
    }
  } else {
    msg_print("But you are not carrying anything.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void mixture_blows_up(char *explode)
{
  boolean dummy;

  msg_print("The mixture blows up!!!");
  dummy = hp_player(-damroll(explode),"an exploding potion");
  msg_print("You are damaged by your feeble attempts at chemistry.");
};
//////////////////////////////////////////////////////////////////////
void make_new_potion(integer result, treasure_type *blegga1,
		     treasure_type *blegga2)
{
  integer        power,p1,p2,i1;
  vtype          out_val, out_val2;
  boolean        flag;
  treasure_type  new_potion;

  msg_print("You successfully mix the two potions together!");
  power = (blegga1->level + blegga2->level) * result;
  p1 = power - 10;
  if (p1 < 0) { p1 = 0; }
  if (p1 > MAX_OBJ_LEVEL) { p1 = MAX_OBJ_LEVEL-20; } /* interesting */
  p2 = power + 10;
  if (p2 > MAX_OBJ_LEVEL) { p2 = MAX_OBJ_LEVEL; }

  /* 
   * make sure that at least one potion exists with a level in p1..p2
   */
  for (flag = false,i1 = max_objects ; (i1 > 0) && !flag ; i1--) {
    if ((object_list[i1].level >= p1) && (object_list[i1].level <= p2)) {
      flag = true;
    }
  }
  if ( !flag ) {
    p1 = 0;
    p2 = MAX_OBJ_LEVEL;
  }

  /*
   * Pick random objects until a potion in the correct range is found.
   */
  do {
    do {
      new_potion = object_list[randint(max_objects)];
    } while (!(new_potion.tval == 75 || new_potion.tval == 76));
  } while (!(new_potion.level >= p1 && new_potion.level <= p2));

  temporary_slot = new_potion;
  inven_carry(&i1);
  objdes(out_val,i1,true,'i');
  sprintf(out_val2, "You have created %s (%c%c",
	  out_val, raoul_label(i1), cur_char1(i1)); 
  msg_print(out_val2);
  msg_print("Congratulations.");
};
//////////////////////////////////////////////////////////////////////
void mix_potions()
{
  /*{ Potions for the mixing!!}*/

  treasure_type   blegga1,blegga2;
  integer         i1,i2,i3,val1,val2;
  boolean         redraw,redraw2;
  obj_set         glug_glug = {75,76};

  reset_flag = true;

  if (inven_ctr == 0) {
    msg_print("You are not carrying anything.");
  } else {
    if (!(find_range(glug_glug,&i2,&i3))) {
      msg_print("You are not carrying any potions.");
    } else {
      redraw  = false;
      redraw2 = false;
      if (get_item(&val1,"Start with which potion?",&redraw,i2,i3)) {
	if (get_item(&val2,"And mix it with which potion?",&redraw2,i2,i3)) {
	  if ((val1 == val2) && (inventory[val1].number == 1)) {
	    msg_print("You can't mix a potion with itself!");
	    msg_print("");
	  } else {
	    if (redraw || redraw2) { draw_cave(); }
	    redraw     = false;
	    redraw2    = false;
	    reset_flag = false;

	    blegga1 = inventory[val1];
	    blegga2 = inventory[val2];
	    if (val1 >= val2) {
	      inven_destroy(val1);
	      inven_destroy(val2);                
	    } else {
	      inven_destroy(val2);
	      inven_destroy(val1);                
	    }

	    i1 = randint(20)+int_adj();
	    if (i1 == 1) {
	      mixture_blows_up("2d20");
	    } else if (i1 < 6) {
	      mixture_blows_up("1d10");
	    } else if (i1 < 16) {
	      msg_print("The mixture dissolves into the air.");
	    } else if (i1 < 20) {
	      make_new_potion(1, &blegga1, &blegga2);
	    } else {
	      /* odd, stupid people can get this */
	      make_new_potion(2, &blegga1, &blegga2);
	    }
	  }
	}
      }
      if (redraw || redraw2) {
	draw_cave();
      }
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE potions.c */
