/* routines.h */
/* in the spirt of millions of globals... */

// { commands.c }
extern void execute_command(integer *com_val);
extern void search_off();
extern void ask_to_quit();
extern void go_up();
extern void go_down();

extern void read_floppy();
extern void eat();
extern void aim();
extern void use();
extern void pray();
extern void quaff();
extern void mix_potions();
extern void use_tech_skills();
extern void use_con_skills();

// { display.inc }
extern boolean inven_command(char command, integer r1, integer r2);
extern boolean get_item(integer *com_val, char *pmt, boolean *redraw,
			integer r1, integer r2 );
extern char raoul_label(integer position);
extern char cur_char1(integer item_val);
extern char cur_char2(integer item_val);

// { MISC.INC		}
extern boolean get_skill( spl_type spell, integer num, integer *sn,
			  integer *sc, char *prompt, boolean *redraw);
extern boolean player_saves(integer adjust);
extern boolean find_range(obj_set item_val, integer *i2, integer *i3);
extern integer attack_blows(integer weight, integer *wtohit);
extern integer critical_blow(integer weight, integer plus, integer dam);
extern void zero_pyflag();
extern integer xbth();
extern integer xbthb();
extern integer xperc();
extern integer xsrh();
extern integer xstl();
extern integer xdis();
extern integer xsave();
extern integer xdev();
extern char *xinfra(vtype out_val);
extern char *likert(integer x,integer y,integer i1);
extern char *cnv_stat (byteint stat, char *out_val);
extern integer lesser(integer a, integer b);
extern integer greater(integer a, integer b);
extern void insert_str(
		       char	*object_str, // : varying[a] of char;
		       char	*mtc_str,    //	: varying[b] of char;
		       char 	*insert_str);// : varying[c] of char); 
extern void insert_num(char *object_str,char *mtc_str, 
		       integer number, boolean show_sign);
extern boolean test_light(integer y,integer x);
extern unsigned long get_seed();
extern void set_seed(unsigned long the_seed);
extern void *save_rand_state(void *randState);
extern void restore_rand_state(void *randState);
extern void init_m_level(); 
extern void init_t_level(); 
extern void price_adjust(); 
extern void sort_objects(); 
extern void change_name(); 
extern void char_inven_init();
extern void gain_mana(integer amount);
extern boolean learn_spell(boolean *redraw);
extern boolean learn_prayer();
extern boolean learn_extra(boolean *redraw);
extern integer int_adj();
extern integer wis_adj();
extern integer chr_adj();
extern integer con_adj();
extern integer todam_adj();
extern integer todis_adj();
extern integer tohit_adj();
extern integer toac_adj();
extern real chr_padj();
extern void prt_stat_block();
extern void prt_winner();
extern void prt_map();
extern integer weight_limit();
extern void prt_max_weight();
extern void prt_depth();
extern void prt_time();
extern void prt_strength();
extern void prt_dexterity();
extern void prt_constitution();
extern void prt_intelligence();
extern void prt_wisdom();
extern void prt_charisma();
extern void prt_pac();
extern void prt_mhp();
extern void prt_title();
extern void prt_level();
extern void prt_hunger();
extern void prt_blind();
extern void prt_confused();
extern void prt_afraid();
extern void prt_poisoned();
extern void prt_chp();
extern void prt_mana();
extern void prt_rest();
extern void prt_search();
extern void prt_gold();
extern void prt_cur_weight();
extern void prt_experience();
extern char loc_symbol(integer y,integer x);
extern char get_loc_symbol(integer y, integer x);
extern void draw_cave(); 
extern integer randnor(integer mean,integer stand);
extern integer rand_rep(integer num, integer die);
extern integer randint(integer maxval);
extern boolean already_playing();
extern boolean check_time();
extern void display_char();
extern void prt_num(vtype header, integer num,integer row,integer column);
extern void inven_carry(integer *item_val);
extern boolean inven_check_weight();
extern boolean inven_check_num();
extern integer how_many_skills(integer adjustment);
extern void print_new_skills(spl_type spell, integer num, boolean *redraw);
extern boolean get_skill(spl_type spell, integer num, integer *sn, 
			 integer *sc, vtype prompt, boolean *redraw);
extern integer bit_pos(unsigned *test);
extern void skill_chance(spl_rec *spell);
extern void draw_the_bus();
extern void put_character();
extern void put_misc1();
extern void put_misc2();
extern void put_misc3();
extern void put_stats();
extern void prt_stat(vtype stat_name,byteint stat,integer row,integer column);
extern byteint de_statp(byteint stat);
extern byteint de_statt(byteint stat);
extern byteint in_statp(byteint stat);
extern byteint in_statt(byteint stat);
extern void alloc_monster(obj_set alloc_set, integer num,
			  integer dis, boolean slp);
extern boolean summon_monster(integer *y, integer *x, boolean slp);
extern boolean summon_undead(integer *y, integer *x);
extern void alloc_object(obj_set alloc_set, integer typ, integer num);
extern void random_object(integer y, integer x, integer num);
extern void blank_cave();
extern void place_boundry();
extern boolean in_bounds(integer y, integer x);
extern void mlink();
extern void tlink();
extern integer next_to8 (integer y, integer x, obj_set group_set);
extern integer next_to4 (integer y, integer x, obj_set group_set);
extern void place_badguy_monster(integer monster);
extern void place_the_boss();
extern integer popt(integer *x);
extern void pusht(integer x);
extern void sort_objects();
extern void place_closed_door(integer y, integer x);
extern void place_locked_door(integer y, integer x);
extern void place_stuck_door(integer y, integer x);
extern void place_secret_door(integer y, integer x);
extern void place_broken_door(integer y, integer x);
extern void place_open_door(integer y, integer x);
extern void place_door(integer y, integer x);
extern void place_up_stairs(integer y, integer x);
extern void place_down_stairs(integer y, integer x);
extern void place_stairs(integer typ, integer num, integer walls);
extern void place_gold(integer y, integer x);
extern void place_trap(integer y,integer x,integer typ,integer subval);
extern void place_rubble(integer y, integer x);
extern void place_object(integer y, integer x);
extern boolean move_dir(integer dir, integer *y, integer *x);
extern integer distance(integer y1,integer x1,integer y2,integer x2);
extern void place_monster(integer y, integer x, integer z, boolean slp);
extern void place_policeman(integer y1,integer x1,integer cop_num);
extern void place_mult_monster(integer y, integer x, integer z, integer repro,
			       boolean slp);
extern void get_random_location(integer *y, integer *x);
extern void bungi(integer y, integer x, integer z, integer cur_pos);
extern integer popm(integer *x);
extern void pushm(integer x);
extern integer get_obj_num(integer level);
extern void compact_objects();
extern void compact_monsters();
extern integer max_hp(dtype hp_str);
extern integer damroll(dtype dice);
extern boolean los(integer y1, integer x1,integer y2,integer x2);
extern boolean delete_object(integer y, integer x);
extern integer maxmin(integer x,integer y,integer z);
extern integer minmax(integer x,integer y,integer z);
extern void mess_with_mind();
extern void carry(integer y,integer x);
extern void area_affect(integer dir, integer y, integer x);
extern boolean pick_dir(integer dir);
extern integer rotate_dir(integer dir,integer rot);
extern integer get_hitdie();
extern void Opusii_vomit(integer percentage);

// { STORE1.INC		}
extern void store_init(); 
extern void store_carry( integer store_num, integer *ipos);
extern void store_destroy(integer store_num, integer item_val, boolean one_of);
extern boolean store_check_num(integer store_num);
extern void store_maint();
extern void do_black_market();
extern integer sell_price (integer snum, treasure_type *item);
extern integer item_value(treasure_type *item);

// { STORE2.INC		}
extern void newsinc();
extern void enter_clinic();
extern void enter_inn();
extern void enter_bank();
extern void enter_store(integer store_num);
extern boolean store_sell(integer store_num, integer cur_top);
extern boolean store_purchase(integer store_num, integer coupon,
                              integer coupon_val, integer *cur_top);
extern integer ask_price(integer store_num,integer *price,treasure_type *item);
extern boolean get_coupon(integer store_num,integer *coup_val,integer cur_top);
extern boolean get_store_item(integer *com_val, char *pmt,
                              integer i1, integer i2);
extern void display_store(integer store_num, integer cur_top);
extern void store_prt_gold();
extern void display_cost(integer store_num, integer pos);
extern void display_inventory(integer store_num, integer start);
extern void display_commands(integer store_num);
extern void prt_comment1();
extern void prt_comment2();


// { MAIN.INC		}
extern void dungeon(); 
extern void add_food(integer num);
extern boolean use_skill(char *prompt, integer item_val, integer *sn,
			 integer *sc, boolean *redraw);
extern boolean twall(integer y, integer x, integer t1, integer t2);
extern void desc_remain(integer item_val);
extern void desc_charges(integer item_val);
extern void rest_off();
extern integer movement_rate(integer speed);
extern void check_mon_lite(integer y, integer x);
extern void gain_level();
extern void midnight();
extern void creatures(boolean attack);
extern void multiply_monster(integer y, integer x, integer z, integer repro, 
			     boolean slp);
extern boolean get_dir(char *promptX, integer *dir, integer *com_val,
		       integer *y, integer *x);
extern void move_char(integer dir);
extern void teleport(integer dis);
extern integer tot_dam(treasure_type *item, integer tdam,
		       creature_type *monster);
extern boolean py_attack(integer y,integer x);
extern void py_bonuses(treasure_type *tobj, integer factor);
extern void monster_death(integer y, integer x, unsigned flags);
extern integer mon_take_hit(integer monptr,integer dam);
extern void place_corpse(integer y, integer x, integer cnum);
extern void delete_monster(integer i2);
extern void search(integer y, integer x, integer chance);
extern void light_room(integer y, integer x);
extern boolean no_light();
extern boolean get_panel(integer y, integer x, boolean forceit);
extern void panel_bounds();
extern void new_spot(integer *y, integer *x);
extern boolean test_hit(integer bth, integer level, integer pth, integer ac);
extern void take_hit(integer damage, char *hit_from);
extern void change_speed(integer num);
extern void move_light(integer y1,integer x1,integer y2,integer x2);
extern void lite_spot(integer y,integer x);
extern void unlite_spot(integer y,integer x);
extern void move_rec(integer y1,integer x1,integer y2,integer x2);
extern byteint change_stat(byteint *stat, integer  amount, integer factor);
extern boolean panel_contains(integer y, integer x);
extern void acid_dam(integer dam, char *kb_str);
extern void light_dam(integer dam, char *kb_str);
extern void fire_dam(integer dam, char *kb_str);
extern void cold_dam(integer dam, char *kb_str);
extern void poison_gas(integer dam, char *kb_str);
extern void corrode_gas(integer dam, char *kb_str);
extern boolean minus_ac(integer typ_dam);
extern integer inven_damage(obj_set typ, integer perc);
extern void inven_destroy(integer item_val);



// { DATAFILES.INC }
extern boolean read_data();
extern boolean get_skill_data(integer number);
extern void read_text_data(integer position, char *filename);

// { GENERATE.INC }
extern void generate_cave();

// { DEATH.INC }
extern void top_twenty(integer points, integer this_many); 
extern void upon_death();
extern void time_out();
extern char* fill_str(char *centered_str, char *in_str, int width);

// { SAVE.INC }
extern boolean get_char(vtype fnam, boolean prop);
extern boolean save_char(boolean quick);

// { DESC.INC }
extern void magic_init(unsigned long random_seed);
extern char *objdes(char *out_val, integer ptr, boolean pref, char which_list);
extern void known1(char *object_str);
extern void known2(char *object_str);
extern void unquote(char *object_str);
extern void identify(treasure_type *item);

// { encrypt.c }
extern void encrypt_init(encrypt_state *state, byteint key[], boolean doit);
extern void encrypt_write(FILE *f1, encrypt_state *state, ntype line);
extern void encrypt_flush(FILE *f1, encrypt_state *state);
extern void read_decrypt(FILE *f1, encrypt_state *state, ntype line,
			 boolean *got_eof);

// { FILES.INC }
extern void look_at_userid();
extern void intro(vtype finam, int argc, char *argv[]); 
extern FILE *priv_fopen( char *path, char *mode);
extern void encrypt_file(vtype fnam);
extern void decrypt_file(vtype fnam);
extern boolean read_top_scores(FILE **f1, char *fnam, string list[],
			       int max_high, int *n1, char *openerr);
extern boolean write_top_scores(FILE **f1, string list[], int max_high);
extern boolean close_top_scores(FILE **f1);
extern char * format_top_score(vtype out_str, char *username, integer score,
			       int diffic, char *charname, int level,
			       char *race, char *class);
extern void character_print();
extern void print_map();

// { HELP.INC }
extern void help();
extern void moria_help(char *help_level);
extern void wizard_help();
extern void ident_char();
extern void do_all_mons();

// { CREATE.INC }
extern void create_character();

// { IO.INC }
extern void init_priv_switch();
extern void priv_switch(integer switch_val); 
extern void controly();
extern void no_controly();
extern void get_paths();
extern void get_foreign(vtype finam);
extern void pause_game(integer prt_line); 

extern void exit_game(); 
extern char inkey();
extern void inkey_delay(char *getchar, integer delay); 
extern void msg_record(vtype message, boolean save); 
extern void flush(); 
extern void inkey_flush(char *x); 
/* use erase_line */
 extern void Erase_Line(
		integer	row,
		integer col);
 extern void clear_rc(integer row,integer col);
/* use print */
 extern void Print(
		char	ch, //	: varying[a] of char;
		int	row,
		int     col); 
 extern void print_str(
		char	*str_buff, //	: varying[a] of char;
		int	row,
		int     col); 

/* use prt */
 extern void Prt(
		char	*str_buff, //	: varying[a] of char;
		int	row,
		int     col); 
 extern void prt2(
		char	*str_buff1, //	: varying[a] of char;
		char	*str_buff2,
		int	row,
		int     col); 
/* use get_string */
 extern boolean Get_String(
		char *in_str,	// : varying[a] of char;
		int row,int column,int slen);
/* use pause_exit */
 extern void Pause_Exit(
		int	prt_line,
		int	delay); 

/* use put_buffer */
extern void Put_Buffer(
		char	*out_str,//	: varying [a] of char;
		integer row,
		integer	col);
extern void put_buffer_attr(
		char	*out_str,//	: varying [a] of char;
		integer row,
		integer	col,
		int     attrs);
extern void put_qio();
/* use clear_from */
extern void Clear_From (int row);
extern void move_cursor_relative(int row, int col);
/* use pause_line */
extern void Pause_Line(int prt_line);

 extern boolean msg_print2(char *str1, char *str2);
 extern boolean msg_print(char *str_buff); // : varying[a] of char);
 extern boolean get_com(
		char *prompt, //	: varying[a] of char;
		char *command);
 extern boolean get_yes_no(char *prompt); // : varying[a] of char);

// { term.c		}
extern void init_curses();
extern void move_cursor_relative(int row, int col);
extern void move_cursor(int row, int col);

// { skills.inc }
extern boolean enchant_weapon(char *how);
extern boolean enchant_armor(char *how);
extern boolean drain_life(integer dir, integer y, integer x);
extern boolean ident_spell();
extern boolean recharge(integer num);
extern boolean protect_evil();
extern boolean light_area(integer y, integer x);
extern boolean unlight_area(integer y, integer x);
extern boolean map_area();
extern boolean protect_evil();
extern boolean speed_monsters(integer spd);
extern boolean speed_monster(integer dir, integer y, integer x, integer spd);
extern boolean trap_creation();
extern boolean door_creation();
extern boolean td_destroy();
extern boolean td_destroy2(integer dir, integer y, integer x);
extern boolean turn_undead();
extern boolean dispell_creature(integer cflag, integer damage);
extern boolean disarm_all(integer dir, integer y, integer x);
extern boolean detect_treasure();
extern boolean detect_sdoor();
extern boolean detect_trap();
extern boolean detect_object();
extern boolean detect_monsters();
extern boolean detect_evil();
extern boolean create_food();
extern boolean wall_to_mud(integer dir, integer y, integer x);
extern boolean warding_glyph(integer y, integer x);
extern boolean destroy_area(integer y, integer x);
extern boolean confuse_monster(integer dir, integer y, integer x);
extern boolean sleep_monsters2_3(integer y, integer x, integer rad);
extern boolean sleep_monster(integer dir, integer y, integer x);
extern boolean hp_monster(integer dir, integer y, integer x, integer dam);
extern boolean hp_player(integer num, char *kind);
extern boolean lose_str();
extern boolean lose_int();
extern boolean lose_con();
extern boolean lose_dex();
extern boolean lose_wis();
extern boolean lose_chr();
extern boolean build_wall(integer dir, integer y, integer x);
extern boolean clone_monster(integer dir, integer y, integer x);
extern boolean restore_level();
extern boolean slow_poison();
extern boolean bless(integer amount);
extern boolean detect_invisible();
extern boolean detect_inv2(integer amount);
extern boolean fire_ball (integer typ, integer dir, integer y, integer x,
			  integer dam_hp, integer radius, boolean painful,
			  char *descrip);
extern void explosion(integer typ, integer y, integer x, integer dam_hp,
		      integer radius, boolean painful, char *descrip);
extern void get_flags (integer typ, integer *weapon_type, integer *harm_type,
		       obj_set **destroy);
extern void make_light(integer y, integer x, integer r, boolean light);
extern boolean teleport_away(integer monptr, integer dis);
extern boolean teleport_to(integer ny, integer nx);
extern boolean teleport_monster(integer dir, integer y, integer x);
extern void lose_exp(integer amount);
extern boolean aggravate_monster(integer dis_affect);
extern boolean cure_confusion();
extern boolean cure_disease();
extern boolean cure_poison();
extern boolean cure_blindness();
extern boolean remove_curse();
extern boolean remove_fear();
extern boolean earthquake();
extern boolean mass_poly();
extern boolean poly_monster(integer dir, integer y, integer x);
extern boolean genocide();
extern boolean mass_genocide();
extern boolean light_line(integer dir, integer y, integer x, integer dmg,
			  boolean laser);
extern boolean fire_bolt  (integer typ, integer dir, integer y, integer x,
			   integer dam, char *bolt_typ);
extern boolean starlite(integer y, integer x);

// { TREASURE.INC }
extern void magic_treasure(treasure_type *item, integer power); 

// { TERMDEF.INC }
extern void termdef();

// { WIERD.INC }
extern void random_wierdness(integer wierd_type, boolean force_wierd);
extern integer query_max_wierd();

// { TRAIN.INC }
extern void training(integer store_num);
extern void get_job();

// { traps.c }
extern void change_trap(integer y, integer x);
extern void hit_trap(integer *y, integer *x);
extern void chest_trap(integer y, integer x);

// { port.c }
extern	void ignore_signals();
extern	void restore_signals();
extern	void default_signals();
extern  char * chomp(char *input_line);
extern  char *strtrim( char *in_line );

// { unix.c }
extern void user_name(char *buf);
extern int check_input(int microsec);

// { wizard.inc }
extern void toggle_wizard_mode();
extern boolean check_pswd();
extern void game_version();
extern void force_wierdness();
extern void wizard_alloc_object();
extern void wizard_exp();
extern void wizard_summon();
extern void really_heal_character();
extern void beckon_creature();
extern void wizard_light();
extern void identify_all();
extern void make_nice_character();
extern void change_location();
extern void change_character();
extern void wizard_help();
extern void print_stuff_to_file();
extern void show_values();
extern void restore_char();
extern void wizard_create();
extern void item_stats();
extern void mon_info();


/* END FILE  routines.h */
