/* create.c */
/**/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void get_name()
{

  /*	{ Gets a name for the character				-JWT-	}*/

  prt("Enter your player's name  [press <RETURN> when finished]",22,3);
  get_string(py.misc.name,3,11,24);
  clear_from(21);

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void change_name()
{
  /* { Chances the name of the character			-JWT-	} */

  char	    c;
  boolean   flag = false;
  
  display_char();

  do {
    prt("<c>hange character name.     <ESCAPE> to continue.",22,3);
    
    c = inkey();
    
    switch (c) {
    case 99: 
      get_name();
      break;
    case 0:
    case 3:
    case 25:
    case 26:
    case 27:
      flag = true;
      break;
    }
    
  } while (!flag);
  
};

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
static integer cc__change_stat(integer cur_stat, integer amount)
{
  /* there is another version of this in main.c */

  /*{ Changes stats by given amount }*/
  integer i;

  if (amount < 0) {
    for (i = -1; i >= amount; i--) {
      cur_stat = de_statp(cur_stat);
    }
  } else {
    for (i = 1; i <= amount; i++) {
      cur_stat = in_statp(cur_stat);
    }
  }

  return cur_stat;
};
//////////////////////////////////////////////////////////////////////
static boolean race_base(integer i2)
{
  /*{Get stats - mwk}*/
  boolean return_value = true;

  py.misc.age = race[i2].b_age + randint(race[i2].m_age);

  //with py. do;
  //with race[i2]. do;

  //with py.stat. do;
  PS.str     = 12;
  PS.int_    = 12;
  PS.wis     = 12;
  PS.dex     = 12;
  PS.con     = 12;
  PS.chr     = 12;
  PS.str     = cc__change_stat(PS.str, race[i2].str_adj);
  PS.int_    = cc__change_stat(PS.int_,race[i2].int_adj);
  PS.wis     = cc__change_stat(PS.wis, race[i2].wis_adj);
  PS.dex     = cc__change_stat(PS.dex, race[i2].dex_adj);
  PS.con     = cc__change_stat(PS.con, race[i2].con_adj);
  PS.chr     = cc__change_stat(PS.chr, race[i2].chr_adj);

  //with py.misc do;
  PM.bth     = race[i2].bbth;
  PM.bthb    = race[i2].bbthb;
  PM.perc    = race[i2].bperc;
  PM.stl     = race[i2].bstl;
  PM.wierd   = race[i2].bwierd;
  PM.save    = race[i2].bsav;
  PM.srh     = race[i2].bsrh;
  PM.hitdie  = race[i2].bhitdie;
  PM.lev     = 1;
  PM.expfact = race[i2].b_exp;
  PM.au      = 400;
  
  PF.see_infra = race[i2].binfra;

  return return_value;
};
//////////////////////////////////////////////////////////////////////
static boolean choose_race()
{
  /*{ Allows player to select a race }*/

  integer   i2,i3,i4,i5;
  char      s;
  vtype     out_val;
  boolean   exit_flag = false;
  boolean   return_value = false;

  i2 = 0;
  i3 = 1;
  i4 = 3;
  i5 = 22;

  clear_from(21);
  prt("Choose a quality (? for Help):",21,3);

  do {
    sprintf(out_val, "%c) %s", (int)i3+96, race[i2].trace);
    put_buffer (out_val,i5,i4);
    i3++;
    i4 += 15;
    if (i4 > 70) {
      i4 = 3;
      i5++;
    }
    i2++;
  } while (i2 < MAX_RACES);

  py.misc.race[0] = 0;
  put_buffer("",21,33);

  do {
    inkey_flush(&s);
    i2 = pindex("abcdefghijklmnopqrstuvwxyz",s) - 1;

    if ((i2 < MAX_RACES) && (i2 >= 0)) {
      //with py. do;
      //with race[i2]. do;
      PM.prace = i2;
      strcpy(PM.race, race[i2].trace);
      race_base(i2);
      exit_flag    = true;
      return_value = true;
      put_buffer(PM.race,4,11);
    } else if (s == '?') {
      moria_help("Character Qualities");
      exit_flag    = true;
      return_value = false;
    }
     
  } while (!exit_flag);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
static void print_history()
{
  /*{Will print the history of a character }*/

  integer   i1;

  put_buffer("Character Background",16,28);
  for (i1 = 1; i1 <= 5; i1++) {
    put_buffer(py.misc.history[i1-1],i1+16,5);
  }
};
//////////////////////////////////////////////////////////////////////
static void wordwrap_history(char *history_block)
{
  integer   start_pos,end_pos,cur_len;
  integer   line_ctr,new_start;
  boolean   flag = false;

  /*{ Process block of history text for pretty output }*/
  start_pos = 0;
  end_pos   = strlen(history_block) - 1;
  line_ctr  = 0;
  
  while (history_block[end_pos] == ' ') {
    end_pos--;
  }

  do {

    while (history_block[start_pos] == ' ') {
      start_pos++;
    }

    cur_len = end_pos - start_pos;
    if (cur_len > 70) {
      cur_len = 70;
      
      while (history_block[start_pos+cur_len-1] != ' ') {
	cur_len--;
      }
      new_start = start_pos + cur_len;
      while (history_block[start_pos+cur_len-1] == ' ') {
	cur_len--;
      }

    } else {
      flag = true;
    }

    strncpy(py.misc.history[line_ctr],history_block+start_pos,cur_len);
    line_ctr++;
    start_pos = new_start;
  } while (!flag);
};
//////////////////////////////////////////////////////////////////////

static void get_history()
{
  /*
    Get the racial history, determines social class 
    Assumtions:   Each race has init history beginning at (race-1)*3+1
                  All history parts are in accending order }
  */

  integer   hist_ptr,cur_ptr,test_roll;
  integer   social_class;
  char      history_block[400];  /*: varying [400] of char;*/
  boolean   flag;

  /*{ Get a block of history text }*/
  hist_ptr = (PM.prace)*3 + 1;
  history_block[0] = 0;
  social_class = randint(4);
  cur_ptr = 0;
  
  do {
    flag = false;
    do {
      cur_ptr++;
      if (background[cur_ptr-1].chart == hist_ptr) {
	test_roll = randint(100);
	
	while (test_roll > background[cur_ptr-1].roll) {
	  cur_ptr++;
	}

	//with background[cur_ptr-1]. do;
	strcat(history_block, background[cur_ptr-1].info);
	social_class += background[cur_ptr-1].bonus;
	if (hist_ptr > background[cur_ptr-1].next) {
	  cur_ptr = 0;
	}

	hist_ptr = background[cur_ptr-1].next;
	flag = true;
      }

    } while (!flag);
  } while (hist_ptr >= 1);

  wordwrap_history( history_block );

  /*{Compute social class for player}*/
  if (social_class > 100) {
    social_class = 100;
  } else {
    if (social_class < 1) {
      social_class = 1;
    }
  }
  py.misc.sc = social_class;

};
//////////////////////////////////////////////////////////////////////
static boolean get_sex()
{
  /*{Gets the character's sex }*/

  integer   i1;
  char      s;
  boolean   exit_flag;
  boolean   return_value;

  py.misc.sex[0] = 0;
  clear_from(21);
  prt("Choose a sex (? for Help):",21,3);
  prt("m) Male       f) Female",22,3);
  prt("",21,29);
  i1 = PM.prace;

  do {
    inkey_flush(&s);
    switch (s) {
    case 'f' : 
      strcpy(py.misc.sex, "Female");
      py.misc.ht = randnor(race[i1].f_b_ht,race[i1].f_m_ht);
      py.misc.wt = randnor(race[i1].f_b_wt,race[i1].f_m_wt);
      prt(py.misc.sex,5,11);
      exit_flag = true;
      return_value = true;
      break;

    case 'm' : 
      strcpy(py.misc.sex, "Male");
      py.misc.ht = randnor(race[i1].m_b_ht,race[i1].m_m_ht);
      py.misc.wt = randnor(race[i1].m_b_wt,race[i1].m_m_wt);
      prt(py.misc.sex,5,11);
      exit_flag = true;
      return_value = true;
      break;

    case '?' : 
      moria_help("Character Sex");
      exit_flag = true;
      return_value = false;
      break;

    default:
      break;
    }
  } while (!exit_flag);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
static boolean get_class()
{
  /*{Gets a character class }*/

  integer   i1,i2,i3,i4,i5;
  integer   cl[MAX_CLASS+1]; // : array [0..max_class] of integer;
  char      s;
  vtype     out_val;
  boolean   exit_flag;         
  boolean   return_value = false;

  for (i2 = 0; i2 <= MAX_CLASS; i2++) {
    cl[i2] = 0;
  }

  i1 = PM.prace;                           
  i2 = 1;
  i3 = 0;
  i4 = 3;
  i5 = 22;

  clear_from(21);
  prt("Choose a class (? for Help):",21,3);

  do {
    /*{if (uand(race[i1-1].tclass,bit_array[i2]) <> 0) then}*/
    {
      i3++;
      sprintf(out_val, "%c) %s", (int)i3+96, class[i2-1].title);
      put_buffer (out_val,i5,i4);
      cl[i3] = i2-1;
      i4 += 15;
      if (i4 > 70) {
	i4 = 3;
	i5++;
      }
    }
    i2++;
  } while (i2 <= MAX_CLASS);

  PM.pclass = 0;
  put_buffer("",21,31);
  exit_flag = false;

  do {
    inkey_flush(&s);
    i2 = pindex("abcdefghijklmnopqrstuvwxyz",s);

    if ((i2 <= i3) && (i2 >= 1)) {
      strcpy(PM.tclass, class[cl[i2]].title);
      PM.pclass = cl[i2];
      exit_flag = true;
      return_value = true;
      clear_from(21);
      put_buffer(PM.tclass,6,11);

      //with py.misc do;
      PM.pskill = class[PM.pclass].skill_no;
      get_skill_data(PM.pskill);  /*{ located in datafiles.inc -RLG }*/
      PM.hitdie  = PM.hitdie  + class[PM.pclass].adj_hd;
      PM.bth     = PM.bth     + class[PM.pclass].mbth;
      PM.bthb    = PM.bthb    + class[PM.pclass].mbthb;
      PM.srh     = PM.srh     + class[PM.pclass].msrh;
      PM.disarm  = PM.disarm  + class[PM.pclass].mdis;
      PM.perc    = PM.perc    + class[PM.pclass].mperc;
      PM.stl     = PM.stl     + class[PM.pclass].mstl;
      PM.wierd   = PM.wierd   + class[PM.pclass].mwierd;
      PM.save    = PM.save    + class[PM.pclass].msav;
      strcpy(PM.title, player_title[PM.pclass][1]);
      PM.expfact = PM.expfact + class[PM.pclass].m_exp;

      /*{ Adjust the stats for the class adjustment }*/
      PS.str  = cc__change_stat(PS.str,class[PM.pclass].madj_str);
      PS.int_ = cc__change_stat(PS.int_,class[PM.pclass].madj_int);
      PS.wis  = cc__change_stat(PS.wis,class[PM.pclass].madj_wis);
      PS.dex  = cc__change_stat(PS.dex,class[PM.pclass].madj_dex);
      PS.con  = cc__change_stat(PS.con,class[PM.pclass].madj_con);
      PS.chr  = cc__change_stat(PS.chr,class[PM.pclass].madj_chr);
      
    } else if (s == '?') {
      moria_help("Character Classes");
      exit_flag = true;
      return_value = false;
      clear_from(1);
    }
  } while (!exit_flag);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
static void spot(integer a,integer b)
{
  put_buffer("*",a,b);
  put_buffer("",a,b);
};
//////////////////////////////////////////////////////////////////////
static void unspot(integer a,integer b)
{
  put_buffer(" ",a,b);
};
//////////////////////////////////////////////////////////////////////
static integer modif_st(integer y, integer x, integer dir, integer stat,
			integer max, integer min, integer amt, integer upp,
			integer *crtpts)
{
  vtype   out_val;

  switch (dir) {
  case 1:   /*{Raise Stat/Lower Points}*/
    if ((stat < max-upp+1) && (*crtpts >= amt)) {
      stat    += upp;
      *crtpts -= amt;
    }
    break;

  case 2:   /*{Raise Stat/Raise Points}*/
    if (stat < max-upp+1) {
      stat    += upp;
      *crtpts += amt;
    }
    break;

  case -1:  /*{Lower Stat/Raise Points}*/
    if (stat > min+upp-1) {
      stat    -= upp;
      *crtpts += amt;
    }
    break;

  case -2:  /*{Lower Stat/Lower Points}*/
    if ((stat > min+upp-1) && (*crtpts >= amt)) {
      stat    -= upp;
      *crtpts -= amt;
    }
    break;

  default:
    break;
  };

  if (y+x != 83) {
    prt_num("",stat,y,x);
  } else {
    sprintf(out_val,"%2.1f",(float)stat/10.0);
    prt(out_val,10,73);
  }

  prt_num("",*crtpts,14,45);

  return stat;
};
//////////////////////////////////////////////////////////////////////
static void alter_stat(integer dir, integer num, integer *crtpts)
{
  integer *c = crtpts;

  switch (num) {
  case 9:  PS.str       = modif_st(7,22,dir,PS.str,50,3,10,1,c);       break;
  case 10: PS.int_      = modif_st(8,22,dir,PS.int_,50,3,10,1,c);      break;
  case 11: PS.wis       = modif_st(9,22,dir,PS.wis,50,3,10,1,c);       break;
  case 12: PS.dex       = modif_st(10,22,dir,PS.dex,50,3,10,1,c);      break;
  case 13: PS.con       = modif_st(11,22,dir,PS.con,50,3,10,1,c);      break;
  case 14: PS.chr       = modif_st(12,22,dir,PS.chr,50,3,10,1,c);      break;
  case 34: PM.bth       = modif_st(7,48,dir,PM.bth,200,1,1,4,c);       break;
  case 35: PM.bthb      = modif_st(8,48,dir,PM.bthb,200,1,1,4,c);      break;
  case 36: PM.save      = modif_st(9,48,dir,PM.save,100,1,2,5,c);      break;
  case 37: PM.stl       = modif_st(10,48,dir,PM.stl,10,1,20,1,c);      break;
  case 38: PM.disarm    = modif_st(11,48,dir,PM.disarm,100,1,2,5,c);   break;
  case 39: PM.wierd     = modif_st(12,48,dir,PM.wierd,100,1,2,5,c);    break;
  case 59: PM.perc      = modif_st(7,73,dir,PM.perc,100,1,2,5,c);      break;
  case 60: PM.srh       = modif_st(8,73,dir,PM.srh,100,1,2,5,c);       break;
  case 61: PF.see_infra = modif_st(9,73,dir,PF.see_infra,20,0,20,1,c); break;
  case 62: PM.expfact   = 
	     modif_st(10,73,2*dir,(int)PM.expfact,30,10,40,1,c);
    break;
  case 63: PM.hitdie    = modif_st(11,73,dir,PM.hitdie,30,4,40,1,c);   break;
  case 64: PM.au        = modif_st(12,73,dir,PM.au,5000,0,1,20,c);     break;
  default:
    break;     
  }
};
//////////////////////////////////////////////////////////////////////
static void skill_adjust()
{
  /*{New method to adjust a new character's skills and stats!!!  -RLG}*/
  
  integer   y,x,crtpts;
  vtype     out_val;
  char      command;
  boolean   exit_flag;

  y = 7;
  x = 2;
  crtpts = 100;

  /* 
   * expfact is the only adjustable stat that is a float.
   * changes will be made in .1 increments, but the adjustment
   * code only plays with integers.  multiply by 10 for now...
   */
  PM.expfact *= 10.0;

  clear_from(1);
  prt("Move the cursor keys (not the arrow keys) to the attribute that",2,5);
  prt("you wish to change. Then use '>' to increase, or '<' to decrease",3,5);
  prt("that attribute. The numbers in paratheses are the amount of change",4,5);
  prt("cost. When you are finished press escape.",5,5);

  //with py.stat. do;
  prt_stat("Strength     (1/10)",PS.str,7,3);
  prt_stat("Intelligence (1/10)",PS.int_,8,3);
  prt_stat("Wisdom       (1/10)",PS.wis,9,3);
  prt_stat("Dexterity    (1/10)",PS.dex,10,3);
  prt_stat("Constitution (1/10)",PS.con,11,3);
  prt_stat("Charisma     (1/10)",PS.chr,12,3);

  //with py.misc. do;
  prt_num("Melee Fighting (5/1)",PM.bth,7,28);
  prt_num("Gun & Grenades (5/1)",PM.bthb,8,28);
  prt_num("Saving Throw   (5/2)",PM.save,9,28);
  prt_num("Stealth       (1/20)",PM.stl,10,28);
  prt_num("Disarming      (5/2)",PM.disarm,11,28);
  prt_num("Wierd Device   (5/2)",PM.wierd,12,28);
  prt_num("Perception     (5/2)",PM.perc,7,53);
  prt_num("Searching      (5/2)",PM.srh,8,53);
  prt_num("Infravision   (1/20)",PF.see_infra,9,53);
  sprintf(out_val, "Expr. Factor (.1/40)%2.1f",PM.expfact/10.0);
  prt(out_val,10,53);
  prt_num("Hit Die       (1/40)",PM.hitdie,11,53);
  prt_num("Starting Cash (20/1)",PM.au,12,53);
  prt_num("Creation Points Left : ",crtpts,14,22);
  print_history();
  prt("Note: Experience Factor is a multiplier of the amount of experience",23,5);
  prt("points your character will need to advance levels.",24,11);

  spot(y,x);

  do {
    command = inkey();

    switch (command) {
    case 27: 
      exit_flag = true;
      break;

    case 50: /* {down} */
      unspot(y,x);
      y++;
      if (y == 13) {
	y = 7;      
      }
      spot(y,x);
      break;

    case 52: /* {left} */
      if (x != 2) {
	unspot(y,x);
	x -= 25;
	spot(y,x);
      }
      break;

    case 54: /* {right} */
      if (x != 52) {
	unspot(y,x);
	x += 25;
	spot(y,x);
      }
      break;

    case 56: /* {up} */
      unspot(y,x);
      y--;
      if (y == 6) {
	y = 12;
      }
      spot(y,x);
      break;

    case 60: case 44: /*{ < (decrease) } */
      alter_stat(-1,x+y,&crtpts);
      break;

    case 62: case 46: /*{ > (increase) } */
      alter_stat( 1,x+y,&crtpts);
      break;

    default:
      break;
    };

  } while (!exit_flag);

  PM.expfact /= 10.0;       /* undo the *= 10.0 from above */

  py.misc.au += 20*crtpts;  /*{Leftover points turn into money}*/

  //with py.stat. do;
  PS.cstr = PS.str;
  PS.cint = PS.int_;
  PS.cwis = PS.wis;
  PS.cdex = PS.dex;
  PS.ccon = PS.con;
  PS.cchr = PS.chr;
  
  //with py.misc. do;
  PM.mhp  = con_adj() + PM.hitdie;
  PM.chp  = PM.mhp;
  
  /*{ Real }*/
  PM.ptodam = todam_adj();
  PM.ptohit = tohit_adj();
  PM.ptoac  = toac_adj();
  PM.pac    = 0;
  
  /*{Display}*/
  PM.dis_th = PM.ptohit;
  PM.dis_td = PM.ptodam;
  PM.dis_tac= PM.ptoac;
  PM.dis_ac = PM.pac;
};
//////////////////////////////////////////////////////////////////////
void create_character()
{
  put_character();
  do {} while(!choose_race());
  do {} while(!get_sex());
  get_history();
  race_base(py.misc.prace);
  get_class();
  skill_adjust();
  put_character();
  put_stats();
  put_misc1();
  put_misc2();
  put_misc3();
  get_name();
  pause_exit(24,0);
  clear_from(1);
  draw_the_bus();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* End FILE create.c */
