/* store2.c */
/* player interaction with the different stores */

#include "boss.h"
#include "main.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void enter_clinic()
{
  /*{ Entering the clinic   -jeb}*/
  
  integer  oa,ob;
  char     command;
  boolean  exit_flag = false;
  
  clear_from(1);
  oa = py.flags.diseased * 10 * py.misc.lev;
  ob = py.misc.au - randint(100);
  
  if (ob < 10000) {
    ob = 10000;
  }
  prt("  Riot Shield medical clinic.       (Dr. Mac 'the knife' Jones)",3,1);
  prt("Options:",5,6);         prt("Cost:",5,66);
  prt("a) Cure disease",6,3);  prt_num("",oa,6,66);
  /*{  prt("b) New Body",7,3);      prt_num("",ob,7,66);}*/
  store_prt_gold();
  
  do {
    get_com("!",&command);
    switch (command) {
    case 97: 
      if (py.misc.au < oa) {
        py.flags.diseased -= ((py.misc.au div 10) div py.misc.lev);
        py.misc.au = 0;
        msg_print("You feel a bit better.");
        pause_game(24);
      } else {
        py.flags.diseased = 0;
        py.misc.au -= oa;
        msg_print("You are Healed!  Be more careful next time.");
        pause_game(24);
      }
      
      if (py.flags.diseased < 0) { py.flags.diseased = 0; }
      if (py.misc.au < 0) { py.misc.au = 0; }
      exit_flag = true;
      break;

    default:
      prt("We don't do _that_ here",1,1);
      exit_flag = true;
      break;
    }
    
  } while (!exit_flag);
  
  draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void newsinc()
{
  /*{ Newsstand/lotto store  --jeb}*/
  
  moria_help("NEWS");
  draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void enter_bank()
{
  /*{ Entering the bank}        */
  
  integer   i1,loan_max;
  char      command;
  boolean   exit_flag,good_val,exit_bank,payoff;
  tentype   tmp_str;
  vtype     out_val;
  
  
  if (payment_count > 10) {
    iod_val   = 0.060 - (0.002 * payment_count);
    iol_val   = 0.100 + (0.005 * payment_count);
    danny_cut = 0.080 + (0.002 * payment_count);
    if (payment_count > 15) {
      principal -= act_bal; /* ouch, he takes it all! */
      act_bal    = 0;
      if (principal < 0) { principal = 0; }
    }
  } else {
    iod_val   = 0.060;     /*{defaults}*/
    iol_val   = 0.100;
    danny_cut = 0.080;
  }
  
  //with py.misc do;
  loan_max = PM.lev * 1000;
  
  /*{loan_max = trunc((player_exp[lev]*expfact)*(-99.0*lev/42.0+102.414634));}*/
  /*{note:  this is engineered to be around $1000 at first level, and
    decreases to player_exp[lev]*expfact at 42nd level.  -jeb}*/
  
  exit_bank = false;
  exit_flag = false;
  payoff    = false;
  
  /*{Display Bank Options}*/
  do {   /*{exit bank loop}*/
    clear_from(1);
    sprintf(out_val, "Danny Dollar    (Bookie)    %s Savings and Loan",
	    townlist[town_num].town_name); 
    prt(out_val,3,10);
    prt_num("Account Balance     :  ",act_bal,7,20);
    prt_num("Interest on Deposit :  ",trunc(100.0*iod_val),8,20);
    prt_num("Loan Principal      :  ",principal,9,20);
    prt_num("Interest on Loans   :  ",trunc(100.0*iol_val),10,20);
    prt_num("Danny's Cut         :  ",trunc(100.0*danny_cut),11,20);
    prt("%",8,46);
    prt("%",10,46);
    prt("%",11,46);
    store_prt_gold();
    prt("You may:",21,1);
    prt("d) Deposit     l) Ask for a loan           ^Z) Exit Danny's S&L",22,1);
    prt("w) Withdraw    p) Make a loan payment                           ",23,1);
    
    if (payment_count > 10) {
      prt("Better get to paying off that loan of yours...",1,10);
    }
    
    do {
      if (get_com("!", &command)) {
        msg_flag = false;
        switch (command) {
        case 100  :    /*{deposit}*/
          exit_flag = true;
          
	  do {
	    good_val = true;
	    prt("How much would you like to deposit?",1,10);
	    get_string(tmp_str,1,47,10);
	    i1 = -1;
	    sscanf(tmp_str,"%ld",&i1);
	    
	    if (i1 > py.misc.au) {
	      good_val = false;
	      msg_print("What, you want I should take the difference out of your gold fillings?");
	      msg_print("");
	    }
	    
	    if (i1 < 0) {
	      good_val = false;
	      msg_print("Look, friend, if you want I should give you money then ask for a loan!");
	      msg_print("");
	    }
	  } while (!good_val);
	  
	  
	  if (py.misc.au == 0) {
	    exit_bank = true;
	    msg_print("Come back when you have some cash");
	    msg_print("");
	  } else if (i1 != 0) {
	    act_bal    += trunc((1.0-danny_cut)*i1);
	    py.misc.au -= i1;
	    msg_print("Your money is safe with me.");
	    msg_print("");
	  }  
	  break;
	  
	case 119  :   
	  if (act_bal == 0) {  /*{withdraw}*/
	    msg_print("You have no money in your account.");
	    msg_print("");
	  } else {
	    exit_flag = true;
	    do {
	      prt("How much would you like to withdraw?",1,10);
	      good_val = true;
	      get_string(tmp_str,1,48,10);
	      i1 = -1;
	      sscanf(tmp_str,"%ld",&i1);
	      if ((i1 < 0) || (i1 > act_bal)) {
		msg_print("Surely you jest.");
		msg_print("");
		good_val = false;
	      }
	    } while (!good_val);
	    
	    if (i1 != 0) {
	      py.misc.au += i1;
	      act_bal -= i1;
	      msg_print("Now don't spend it all in one place.");
	      msg_print("");
	    } else {
	      msg_print("Come back if you change your mind.");
	    }
	  }
	  break;
	  
	case 108  :    /*{loan}*/
	  do {
	    good_val = true;
	    prt("How much do you need?",1,10);
	    get_string(tmp_str,1,32,10);
	    i1 = -1;
	    sscanf(tmp_str,"%ld",&i1);
	    if (i1 < 0) { good_val = false; }
	  } while (!good_val);
	  
	  if (i1 + principal > loan_max) {
	    msg_print("I don't think you're good for that much.");
	  } else if (i1 == 0) {
	    msg_print("What, you just like to fill out paperwork?");
	  } else {
	    py.misc.au += i1;
	    principal  += i1;
	    exit_flag   = true;
	  }
	  break;
	  
	case 112:   /*{pay off loan}*/
	  do {
	    good_val = true;
	    prt("How much would you like to pay?",1,10);
	    get_string(tmp_str,1,43,10);
	    sscanf(tmp_str,"%ld",&i1);
	    if (i1 < 0) { good_val = false; }
	  } while (!good_val);
	  
	  if (i1 > py.misc.au) {
	    msg_print("You're already in debt, don't try to pay with money you don't have.");
	    msg_print("");
	  } else if (i1 == 0) {
	    msg_print("Ok, more interest for me then.");
	    msg_print("");
	  } else {
	    if (i1 > principal) {
	      msg_print("Hey!  Thanks for the tip!");
	    }
	    principal -= i1;
	    if (principal < 0)  { principal = 0; }
	    if (principal == 0) { payment_count = 0; }
	    py.misc.au -= i1;
	    exit_flag   = true;
	    payoff      = true;
	  }
	  break;
	  
	default:
	  prt("Invalid Command.",1,1);    
	  break;
	}
      } else {
	exit_flag = true;
	exit_bank = true;
      }
      
    } while(!exit_flag);
  } while (!exit_bank);
  if (py.misc.au < 0) { py.misc.au = 0; }
  if (! payoff && (principal > 0)) { payment_count++ ; }
  msg_print("");
  draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void enter_inn()
{
    /*{ Entering a hotel}*/

  integer  i5,com_val,oa,ob,oc,od,oe; 
  char     option,command;
  boolean  exit_flag;
  vtype    hungry;

  exit_flag = false;
  strcpy(hungry,  "You are too hungry to sleep right now.");
  clear_from(1);
  i5 = turn;
  oa = trunc(5 + 5*chr_padj());      ob = trunc(2 + 1*chr_padj());
  oc = trunc(20 + 20*chr_padj());    od = trunc(50 + 50*chr_padj());
  oe = trunc(500 + 500*chr_padj());

  /*{Display Hotel Options}*/
  prt("Max Footroom      (Proprieter)    Paradise Hotel",3,10);
  prt("     Options:",5,1);          prt("  Set Price:",5,61);
  prt("  a) Light Meal",7,1);        prt_num("",oa,7,66);
  prt("  b) Short Nap",8,1);         prt_num("",ob,8,66);
  prt("  c) Overnight Stay",9,1);    prt_num("",oc,9,66);
  prt("  d) Executive Suite",10,1);  prt_num("",od,10,66);
  prt("  e) Mud Bath",11,1);     prt_num("",oe,11,66);
  store_prt_gold();
  prt("You may:",21,1);
  prt("  p) Pay for Option.                   c) Catch a bus.",22,1);
  prt(" ^Z) Exit from Building.               j) Apply for a Job.",23,1);

  do {
    if (get_com("!",&command)) {
      msg_flag = false;

      switch (command) {
      case 106  : 
        if (py.flags.food < 1000) {
          msg_print("You are too hungry to work");
        } else if ((turn > 4320) && (turn < 12960)) {
          get_job();  /*{procedure in train.inc}*/
        } else {
          msg_print("We are not hiring right now.");
        }
        msg_print("");
        exit_flag = true;
        break;

      case 99 :
        if (town_num == MAX_TOWNS) {
          msg_print("The bus station has been destroyed.");
        } else if (!defeated_badguy) {
          msg_print("You can't seem to find a bus.");
          msg_print("Try again after you have defeated the mob "
                    "boss of this city.");
        } else if (payment_count > 10) {
          msg_print("Danny's goons throw you off the bus!");
          msg_print("'Pay off your loan!!'");
        } else if (py.flags.food < 2200) {
          msg_print("Your stomach is growling.");
          msg_print("You'd better eat before you leave.");
        } else if (py.misc.au < 50) {
          msg_print("The bus fare is $50, which you don't have.");
        } else {
          turn += 10000;
          py.flags.food -= 200;
          py.misc.au -= 50;
          town_num++;
          draw_the_bus();          /*{code located in misc.inc}*/
          town_seed = get_seed();
          store_init();
          defeated_badguy = false;
          py.misc.max_lev = 0;
          moria_flag = true;       /*{will draw new cave on exit}*/
          office_char_row = -1;
          office_char_col = -1;
          exit_flag = true;
        }
        break;
        
      case 112  : 
        prt("What would you like?",1,1);
        exit_flag = get_com("!",&option);
        break;
        
      default:
        prt("Invalid Command.",1,1);    
        break;
      }
    } else {
      exit_flag = true;
    }
  } while (!exit_flag);
  
  switch (option) {
    
  case 97:
    if (py.misc.au < oa) {
      msg_print("What! You don't have enough money!");
    } else {
      msg_print("You eat a light meal at the hotel.");
      py.misc.au -= oa;
      py.flags.food += 3000;
      turn += 360;
      zero_pyflag();
    }
    break;
    
  case 98:
    if (py.misc.au < ob) {
      msg_print("You can't even afford to sleep on the lobby couch!");
    } else if (py.flags.food < 300) {
      msg_print(hungry);
    } else {
      msg_print("You take a short nap at the hotel.");
      py.misc.au -= ob;
      py.flags.food -= 300;
      py.misc.chp   += (py.misc.mhp - py.misc.chp) / 3;
      turn += 720;
      zero_pyflag();
    }
    break;
    
  case 99:
    if (py.misc.au < oc) {
      msg_print("You can't afford a room, sorry.");
    } else if (py.flags.food < 700) {
      msg_print(hungry);
    } else {
      msg_print("You spend the night at the hotel.");
      py.misc.au    -= oc;
      py.flags.food = 1100 + randint(20);  /*{small breakfast}*/
      midnight();
      turn = 5800;
    }
    break;
    
  case 100:
    if (py.misc.au < od) {
      msg_print("You cannot afford our luxury suite.  Begone, vermin!");
    } else if (py.flags.food < 700) {
      msg_print(hungry);
    } else {
      msg_print("You purchase a night in the finest suite of the hotel.");
      py.misc.au -= od;
      py.flags.food = 7500;   /*{ large breakfast...  --jeb}*/
      midnight();
      turn = 5800 + randint(1000);
    }
    break;
    
  case 101:
    if (py.misc.au < oe) {
      msg_print("Our mud baths are for paying customers only!");
    } else if (py.flags.food < 400) {
      msg_print("You are too hungry to think about mud.");
    } else {
      msg_print("You relax in a soothing vat of mud.");
      py.flags.food -= 360;
      turn += 720;
      zero_pyflag();
      //with py.stat do;
      PS.cstr = PS.str;  PS.cint = PS.int_; PS.cwis = PS.wis;
      PS.cdex = PS.dex;  PS.ccon = PS.con;  PS.cchr = PS.chr;
      
      //with py.misc do;
      PM.au   -= oe;
      PM.chp   = PM.mhp;  
      PM.cmana = PM.mana;
    }
    break;
    
  default: 
    turn += 12;
    break;
  }
  
  /*{If option makes a day go by, then...}*/
  if ((com_val == 99 || com_val == 100) && (turn != i5)) {
    zero_pyflag();
    py.misc.chp    = py.misc.mhp;
    py.misc.cmana  = py.misc.mana;
  }
  
  /*{Safe-check effects of all options:}*/
  if (py.misc.au < 0)     { py.misc.au    =  0; }
  if (py.flags.food < 10) { py.flags.food = 10; }
  if ((i5 < 4320)  && (turn > 4320))  { moria_flag = true; }
  if ((i5 < 12960) && (turn > 12960)) { moria_flag = true; }
  if ((i5 < 8640)  && (turn > 8640))  { store_maint(); }
  if (turn > 17280) {
    midnight();
  }

  msg_print("");
  draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void enter_store(integer store_num)
{
    /*{ Entering a store }*/

  integer   cur_top,coup_val,dummy;
  char      command;
  boolean   exit_flag,coupon; 
 
  dummy  = 1;
  coupon = false;
  
  //with stores[store_num]. do;
  if ((store_num == 7) && (py.misc.au < 500)) {
    msg_print("The bouncer says that you're too poor to enter.");
  } else if (((stores[store_num].store_open > day) || 
	      (turn > 12960) || (turn < 4320)) 
             && (store_num != 7)) {
    msg_print("The doors are locked.");
  } else {
    exit_flag = false;
    cur_top   = 1;
    display_store(store_num,cur_top);
    
    do {
      if (get_com("!",&command)) {
        msg_flag = false;
        switch (command) {
        case 18      : 
          display_store(store_num,cur_top);
          break;
          
        case 20      :   /*{specific training}*/
          training(store_num);
          exit_flag = true;
          break;
          
        case 32      :   /*{browse inventory}*/
          if (cur_top == 1) {
            if (stores[store_num].store_ctr > 12) {
              cur_top = 13;
              display_inventory(store_num, cur_top);
            } else {
              prt("Entire inventory is shown.",1,1);
            }
          } else {
            cur_top = 1;
            display_inventory(store_num,cur_top);
          }
          break;
          
        case 101     :    /*{ Equipment List        }*/
          if (inven_command('e',0,0)) {
            display_store(store_num,cur_top);
          }
          break;
          
        case 105     :    /*{ Inventory             }*/
          if (inven_command('i',0,0)) {
            display_store(store_num,cur_top);
          }
          break;
          
        case 109     :    /*{ Make an item     }*/
          if (store_num == 7) {
            prt("Command not implemented yet.",1,1);
          } else {
            prt("Invalid Command.",1,1);
          }
          break;
          
        case 116     :    /*{ Take off              }*/
          if (inven_command('t',0,0)) {
            display_store(store_num,cur_top);
          }
          break;
          
        case 119     :    /*{ Wear                  }*/
          if (inven_command('w',0,0)) {
            display_store(store_num,cur_top);
          }
          break;
          
        case 120     :    /*{ Switch weapon         }*/
          if (inven_command('x',0,0)) {
            display_store(store_num,cur_top);
          }
          break;
          
        case 112     : 
          coupon = false;
          exit_flag = store_purchase(store_num,coupon,dummy,&cur_top);
          break;
          
        case 117     : 
          if (get_coupon(store_num,&coup_val,cur_top)) {
            coupon = true;
            exit_flag = store_purchase(store_num,coupon,coup_val,&cur_top);
          }
          break;
          
        case 115     : 
          exit_flag = store_sell(store_num,cur_top);
          break;
          
        default:
          prt("Invalid Command.",1,1);
          break;
        }
      } else {
        exit_flag = true;
      }
    } while (!exit_flag);
    draw_cave();
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean store_sell(integer store_num, integer cur_top)
{
    /*{ Sell an item to the store }*/

  integer   item_val;
  integer   item_pos,price;
  boolean   redraw = false;
  vtype     out_val, out_val2;
  boolean   return_value = false;
  
  //with stores[store_num] do;
  
  if (get_item(&item_val,"Sell which item?",&redraw,1,inven_ctr)) {
    if (redraw) { display_store(store_num,cur_top); }
    
    temporary_slot = inventory[item_val];
    //with temporary_slot. do;
    if ((temporary_slot.subval > 255) && (temporary_slot.subval < 512)) {
      temporary_slot.number = 1;
    }
    
    objdes(out_val,1,true,'t');
    sprintf(out_val2, "Selling %s (%c)", out_val, (int)item_val+96);
    msg_print(out_val2);
    msg_print(" ");
    
    if (is_in(temporary_slot.tval, store_buy[store_num])) {
      if (store_check_num(store_num)) {
	
	switch (ask_price(store_num,&price,&temporary_slot)) {
	case 0 : 
	  prt_comment1();
	  py.misc.au += price;
	  inven_destroy(item_val);
	  store_carry(store_num,&item_pos);
	  if (item_pos > 0) {
	    if (item_pos < 13) {
	      if (cur_top < 13) {
		display_inventory(store_num,item_pos);
	      } else {
		display_inventory(store_num,cur_top);
	      }
	    } else if (cur_top > 12) {
	      display_inventory(store_num,item_pos);
	    }
	  }
          store_prt_gold();
	  break;
	  
	case 2 : 
	  return_value = true;
	  break;
	  
	case 3 :
	  msg_print("How dare you!");
	  msg_print("I will not buy that!");
	  break;
	  
	default:
	  break;
	}
	
      } else {
	prt("I have not the room in my store to keep it...",1,1);
      }
    } else {
      prt("I do not buy such items.",1,1);
    }
  } else if (redraw) {
    display_store(store_num,cur_top);
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean store_purchase(integer store_num, integer coupon,
                       integer coupon_val, integer *cur_top)
{    
  /*{ Buy an item from a store                              -RAK-   }*/

  integer    i1,item_val,price;
  integer    item_new;
  integer    save_number;
  real       per_off;
  vtype      out_val, out_val2;

  boolean    return_value = false;

  //with stores[store_num]. do;

  /*{ i1 = number of objects shown on screen }*/
  if (*cur_top == 13) {
    i1 = stores[store_num].store_ctr - 12;
  } else if (stores[store_num].store_ctr > 12) {
    i1 = 12;
  } else {
    i1 = stores[store_num].store_ctr;
  }

  if (stores[store_num].store_ctr < 1) {
    msg_print("I am currently out of stock.");
                                                /*{get coupon value}*/
  } else if (get_store_item(&item_val,          /*{Get the store item number}*/
                            "Which item are you interested in? ",1,i1)) {
    item_val += *cur_top - 1;     /*{ true item_val }*/
    temporary_slot = stores[store_num].store_inven[item_val].sitem;
    price  = abs(stores[store_num].store_inven[item_val].scost);
    price += trunc(price*chr_padj());
    if (coupon) {
      per_off = (100 - inventory[coupon_val].p1)/100;
      price = trunc(price*per_off);
      inven_destroy(coupon_val);
    }
    if (price < 1) { price = 1; }

    //with temporary_slot. do;
    if ((temporary_slot.subval > 255) && (temporary_slot.subval < 512)) {
      save_number = temporary_slot.number;
      temporary_slot.number = 1;
    } else {
      save_number = 1;
    }

    if (inven_check_weight) {
      if (inven_check_num) {
	if (wizard) {
	  py.misc.au += price;
	}

	if (py.misc.au < price) {
	  msg_print("You Scum!  Cough up more dough!");
	} else {
	  if (coupon) {
	    prt_comment2(price);
	  } else {
	    prt_comment1();
	  }

	  py.misc.au -= price;
	  store_destroy(store_num,item_val,true);
	  inven_carry(&item_new);
	  objdes(out_val,item_new,true,'i');
	  sprintf(out_val2, "You have %s (%c)", out_val, (int)item_new+96);
	  msg_print(out_val2);

	  if (*cur_top > stores[store_num].store_ctr) {
	    *cur_top = 1;
	    display_inventory(store_num,*cur_top);
	  } else {
	    //with store_inven[item_val] do;
	    display_inventory(store_num,item_val);
	    store_prt_gold();
	  }
	}

	prt("",2,1);

      } else {
	prt("You cannot carry that many different items.",1,1);
      }
    } else {
      prt("You can not carry that much weight.",1,1);
    }
  }
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer ask_price(integer store_num, integer *price, treasure_type *item)
{
  /*
    { Returns whether a sale has been made and the selling price}
    {0- sale ,  2- no sale ,  3- player tryed to sell valueless item}
  */
  integer   cost;
  char      accept; 
  integer   return_value = 0;

  *price    = 0;
  msg_flag  = false;

  //with stores[store_num] do;
  cost = item_value(item);
  if (cost < 1) {
    return_value = 3;
  } else {
    //with owners[store_num][town_num]. do;
    cost  -= ( trunc(cost*chr_padj()) +
	       trunc(cost*rgold_adj[owners[store_num][town_num].owner_class][py.misc.pclass]) );
    cost   = trunc(cost*(1-owners[store_num][town_num].sell_deflate));
    if (cost < 1) { cost = 1; }

    *price = cost;
    prt_num("Hmmmm, that's worth: ", *price,2,2);
    msg_print("");
    if (get_com("Accept the Offer? (y/n)", &accept)) {
      if (accept == 'y') {
	return_value = 0;
      } else {
	return_value = 2;
      }
    } else {
      return_value = 2;
    }
    prt("",2,1);
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean get_coupon(integer store_num, integer *coup_val, integer cur_top)
{
  /*{ Returns the char inven position of a coupon} */

  integer     i2,i3;
  boolean     redraw = false;
  obj_set     coupons = {3};
  boolean     return_value = false;
  
  if (!(find_range(coupons,&i2,&i3))) {
    msg_print("You don't have any coupons.");
  } else {
    if (get_item(coup_val,"Use which coupon?", &redraw,i2,i3)) {
      if (redraw) { display_store(store_num,cur_top); }
      //with inventory[*coup_val]. do;
      if ((inventory[*coup_val].subval == store_num) || 
	  (inventory[*coup_val].subval == 20)) {
	return_value = true;
      } else {
	msg_print("I cannot accept that!");
      }
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean get_store_item(integer *com_val, char *pmt, integer i1, integer i2)
{
  /*{ Get the ID of a store item and return it's value      -RAK-   }*/

  char      command;
  vtype     out_val;
  boolean   flag;

  *com_val = 0;
  flag = true;

  sprintf(out_val,"(Items %c-%c, ^Z to exit) %s",(int)i1+96,(int)i2+96,pmt);

  while (((*com_val < i1) || (*com_val > i2)) && (flag)) {
    prt(out_val,1,1);
    command = inkey();
    switch (command) {
    case 3: case 25: case 26: case 27:    flag = false;   break;
    default: *com_val = command - 96;                     break;
    }
  }

  msg_flag = false;
  erase_line(msg_line,msg_line);
  return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void display_store(integer store_num, integer cur_top)
{
  /*{ Displays store                                        -RAK-   }*/

  //with stores[store_num] do;
  clear_from(1);
  prt(owners[store_num][town_num].owner_name,3,10);
  prt("   Item",5,1);
  prt("Today's Price",5,60);
  store_prt_gold();
  display_commands(store_num);
  display_inventory(store_num,cur_top);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void store_prt_gold()
{
  /*{ Displays players gold                                 -RAK-   }*/

  vtype  out_val;
  
  sprintf(out_val,"Dollars Remaining : %ld", py.misc.au);
  prt(out_val,19,20);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void display_cost(integer store_num, integer pos)
{
  /*{ Re-displays only a single cost                        -RAK-   }*/

  integer    i1, i2;
  vtype      out_val;

  //with stores[store_num]. do;
  i1 = ((pos-1) % 12);
  if (stores[store_num].store_inven[pos].scost < 0) {
    i2  = abs(stores[store_num].store_inven[pos].scost);
    i2 += trunc(i2*chr_padj());
    sprintf(out_val,"%7ld", i2);
  } else {
    sprintf(out_val,"%7ld [Sale]", stores[store_num].store_inven[pos].scost);
  }

  prt(out_val,i1+6,60);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void display_inventory(integer store_num, integer start)
{
  /*{ Displays a store's inventory }*/

  integer   i1,i2,stop;
  vtype     out_val1,out_val2;

  //with stores[store_num]. do;

  i1   = ((start-1) % 12);
  stop = (((start-1) div 12) + 1)*12;
  if (stop > stores[store_num].store_ctr) { 
    stop = stores[store_num].store_ctr;
  }

  while (start <= stop) {
    temporary_slot = stores[store_num].store_inven[start].sitem;
    //with temporary_slot. do;
    if ((temporary_slot.subval > 255) && (temporary_slot.subval < 512)) {
      temporary_slot.number = 1;
    }

    objdes(out_val1,1,true,'t');
    sprintf(out_val2,"%c) %s",(int)(97+i1),out_val1);
    prt(out_val2,i1+6,1);

    if (stores[store_num].store_inven[start].scost < 0) {
      i2  = abs(stores[store_num].store_inven[start].scost);
      i2 += trunc(i2*chr_padj());
      sprintf(out_val2,"%7ld",i2);
    } else {
      sprintf(out_val2,"%7ld [Sale]", 
	      stores[store_num].store_inven[start].scost);
    }
    prt(out_val2,i1+6,60);

    i1++;
    start++;
  }

  if (i1 < 12) {
    for (i2 = 1; i2 <= (12 - i1 + 1); i2++) {
      prt("",i2+i1+5,1);
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void display_commands(integer store_num)
{
  /*{ Displays the set of commands }*/

prt("You may:",20,3);
prt(" p) Purchase an Item.        space) Browse store's inventory.",21,3);
prt(" s) Sell an Item                 i) Inventory and Equipment Lists.",22,3);
prt(" u) Use a Coupon.               ^R) Redraw the screen.",23,3);
prt("^Z) Exit from Building.         ^T) Seek Special Training.",24,3);

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_comment1()
{
  /*{ Comment one : Item is sold.}*/

  msg_flag = false;
  switch (randint(12)) {
  case  1  : msg_print("Done!");                                break;
  case  2  : msg_print("Accepted!");                            break;
  case  3  : msg_print("Fine...");                              break;
  case  4  : msg_print("Agreed!");                              break;
  case  5  : msg_print("Ok...");                                break;
  case  6  : msg_print("Sold!");                                break;
  case  7  : msg_print("You'll force me to bankrupt...");       break;
  case  8  : msg_print("Sigh...");                              break;
  case  9  : msg_print("My poor sick children may starve...");  break;
  case 10  : msg_print("Robbed again...");                      break;
  case 11  : msg_print("A pleasure to do business with you!");  break;
  case 12  : msg_print("My spouse shall skin me...");           break;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_comment2(integer cash)
{
  /*{ Comment two : Item is sold with a coupon - RLG.}*/

  vtype   out;

  msg_flag = false;
  switch (randint(5)) {
  case 1 : sprintf(out,"Done!  For the low, low price of $%ld",cash);    break;
  case 2 : sprintf(out,"Sold!  For the extra cheap price of $%ld",cash); break;
  case 3 : sprintf(out,"Congrats. El Cheapo price, $%ld",cash);          break;
  case 4 : sprintf(out,"Agreed!  LOW PRICE: $%ld",cash);                 break;
  case 5 : sprintf(out,"Ok...  You got away with it for only $%ld",cash);break;
  }
  msg_print(out);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/* END FILE store2.c */
