/* values.h */
/* This should only be included from boss.c, other files use variables.h */

FILE       *tempfile; //{debugging file}
boolean     scumuser  = false;//{used when detecting users who shouldn't play}
boolean     putzuser  = false;
boolean     validuser = false;
//    resist_gas : [psect(player$data)] boolean;  {Soon to be a py.flag}
integer     max_weight;
boolean     is_boss_dead = false;
integer     total_winner_num = 0;
boolean     defeated_badguy = false;
boolean     out_of_time = false; //{ 100-day time limit flag. -jeb}
integer     max_creatures;       //{total # of monsters in mlist}
integer     max_objects;         //{total # in objects.dat }
integer     inven_init_max;      //{ Size of store inventory }
integer     player_max_exp;      //{ Max exp possible    }
unsigned    seed;                //{ Contains seed # }
unsigned    randes_seed;         //{ For encoding colors }
unsigned    town_seed;           //{ Seed for town generator }
integer     channel;             //{ I/O channel #   }
quad_type   io_bin_pause;        //{ I/O pause time  }
integer     cur_height,cur_width;//{ Cur dungeon size}
integer     dun_level;           //{ Cur dungeon level   }
integer     dun_power;           //{ Cur power of dun level}
integer     town_num = 1;        //{ Cur town player is in -RLG}
integer     missle_ctr;          //{ Counter for missles }
integer     msg_line;            //{ Contains message txt}
boolean     msg_flag;            //{ Set with first msg  }
boolean     more_flag = false;   //{ Question -more- on/off -jeb}
boolean     wall_flag = true;    //{ Toggle Neat Wall Paterns. -RLG}
vtype       old_msg;             //{ Last message    }
boolean     generate;            //{ Generate next level }
boolean     death = false;       //{ True if died    }
vtype       died_from;           //{ What killed him }
boolean     find_flag;           //{ Used in MORIA   }
boolean     reset_flag;          //{ Used in MORIA   }
boolean     cave_flag;           //{ Used in GET_PANEL   }
boolean     light_flag;          //{ Used in MOVE_LIGHT  }
boolean     redraw;              //{ For redraw screen   }
integer     stat_column = 1;     //{ Column for stats    }
unsigned    print_stat = 0;      //{ Flag for stats  }
integer     turn;                //{ Cur turn of game    }
integer     day = 1;             //{ day counter     -RLG   }
boolean     wizard = false;      //{ Wizard flag }
boolean	    used_line[24] =      // 22 of false
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
usernam_type    password1;
usernam_type    password2;

	// { Operating hours for Moria				-RAK-	}
	// {	X = Open; . = Closed					}
char		days[7][30] =
		{
		"SUN:XXXXXXXXXXXXXXXXXXXXXXXX|",
		"MON:XXXXXXXXXXXXXXXXXXXXXXXX|",
		"TUE:XXXXXXXXXXXXXXXXXXXXXXXX|",
		"WED:XXXXXXXXXXXXXXXXXXXXXXXX|",
		"THU:XXXXXXXXXXXXXXXXXXXXXXXX|",
		"FRI:XXXXXXXXXXXXXXXXXXXXXXXX|",
		"SAT:XXXXXXXXXXXXXXXXXXXXXXXX|"
		};
/*
char		days[7][30] =
		{
		"SUN:XXXXXXXXXXXXXXXXXXXXXXXX|",
		"MON:XXXXXXXX.........XXXXXXX|",
		"TUE:XXXXXXXX.........XXXXXXX|",
		"WED:XXXXXXXX.........XXXXXXX|",
		"THU:XXXXXXXX.........XXXXXXX|",
		"FRI:XXXXXXXX.........XXXXXXX|",
		"SAT:XXXXXXXXXXXXXXXXXXXXXXXX|"
		};
*/		

integer     closing_flag = 0;  //{ Used for closing   }

    //{Bank Stuff} 
integer     act_bal = 0;
integer     principal = 0;
integer     payment_count = 0;
real        iod_val = 0, iol_val = 0, danny_cut = 0;
    
    //{ Bit testing array }
unsigned	bit_array[33] =  //  array [1..32] of unsigned;
	    {0, 0x00000001, 0x00000002, 0x00000004, 0x00000008,
		0x00000010, 0x00000020, 0x00000040, 0x00000080,
		0x00000100, 0x00000200, 0x00000400, 0x00000800,
		0x00001000, 0x00002000, 0x00004000, 0x00008000,
		0x00010000, 0x00020000, 0x00040000, 0x00080000,
		0x00100000, 0x00200000, 0x00400000, 0x00800000,
		0x01000000, 0x02000000, 0x04000000, 0x08000000,
		0x10000000, 0x20000000, 0x40000000, 0x80000000};
 
    //{ External file names; are all located in directory with image  }
vtype    BOSS_HOU,BOSS_MOR;
vtype    BOSS_MAS,BOSS_TOP;    
vtype    BOSS_HLP,BOSS_MON;
vtype    BOSS_OBJ,BOSS_LOS;
vtype    BOSS_WIZ,BOSS_ANNOY;
vtype    BUS_PIC ,QUOTES;
vtype    BOSS_INV,SKILLS;
   
    //{  Following are calculated from max dungeon sizes  }
integer    max_panel_rows,max_panel_cols;
integer    quart_height,quart_width;
integer    panel_row,panel_col;
integer    panel_row_min,panel_row_max;
integer    panel_col_min,panel_col_max;
integer    panel_col_prt,panel_row_prt;
 
    //{  Following are all floor definitions  }
row_floor       cave[MAX_HEIGHT+1];
cave_type       blank_floor = {0,0,0,false,false,false,false};
floor_type	dopen_floor = {1,true}; //{ Dark open floor	}
floor_type	lopen_floor = {2,true}; //{ Light open floor	}
floor_type	corr_floor1 = {4,true}; //{ Corridor open floor	}
floor_type	corr_floor2 = {5,true}; //{ Room junction marker}
floor_type	corr_floor3 = {6,true}; //{ Door type floor	}
floor_type	corr_floor4 = {7,false};//{ Secret door type floor}
    //{ Floor values 8 and 9 are used in generate		}
floor_type	rock_wall1  = {10,false};//{ Granite rock wall	}
floor_type	rock_wall2  = {11,false};//{ Magma rock wall	}
floor_type	rock_wall3  = {12,false};//{ Quartz rock wall	}
floor_type	water1      = {16,true}; //{ Water on floor	}
floor_type	water2      = {17,true}; //{ Water on room floor}
floor_type	water3      = {18,true}; //{ Lit water on floor	}
floor_type	boundry_wall= {15,false};//{ Indestructable wall}
 
    //{  Following are set definitions    }
obj_set    floor_set = {1,2,4,5,6,7,0};
obj_set    wall_set  = {10,11,12,0};
obj_set    pwall_set = {10,11,12,15,0};
obj_set    corr_set  = {4,5,0};
obj_set	   earth_set = {1,2,4,5,6,7,0,0,0,0,0,0,0,0,0,0};
obj_set	   water_set = {16,17,18,0,0,0,0,0,0,0,0,0,0,0,0,0};
obj_set    trap_set  = {101,102,109,110,111,120,0};
obj_set    light_set = {102,103,104,105,107,108,109,110,111,0};
integer    circle[10] = {-99,3,3,3,2,2,2,1,1,0};  //{Circle Room}

//{neatness arrays}
byteint		key_of[9] =	//  array [0..8] of byteint;
{6,9,8,7,4,1,2,3,5};
byteint		oct_of[10] =	//  array [1..9] of byteint;
{250,5,6,7,4,8,0,3,2,1};
bytlint		dx_of[10] =	//  array [1..9] of bytlint;
{250,-1,0,1,-1,0,1,-1,0,1};
bytlint		dy_of[10] =	//  array [1..9] of bytlint;
{250,1,1,1,0,0,0,-1,-1,-1};

    //{ Following are player variables    }
player_type    py =
{        {" "," "," "," "," ",
         0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         {"","","","",""},0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,5000,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
         false,false,false,false,false,false,false,false,false,
         false,false,false,false,false,false,false,false,false,false}
};

btype	player_title[MAX_CLASS+1][MAX_PLAYER_LEVEL+1] = 
//				  array [1..max_class] of
//				  array [1..max_player_level] of btype;
{

// Wrestler
{"Jock Strap","Jock Strap",
"Trainee","Trainee","Trainee","Trainee","Trainee","Trainee",
"Athlete","Athlete","Athlete","Athlete","Athlete","Athlete",
"Jock","Jock","Jock","Jock","Jock","Jock",
"Hunk","Hunk","Hunk","Hunk","Hunk","Hunk",
"Stud","Stud","Stud","Stud","Stud","Stud",
"Champ","Champ","Champ","Champ",
"Pro","Pro","Pro","Pro","Hulk","Hulk"},
        
// Scientist
{"In the dark","In the dark","Sees the Light","Beginner",
"Beginner","Student","Student","Novice","Novice","Hobbiest",
"Hobbiest","Tinkerer","Tinkerer","Frosh","Frosh","Sophomore","Sophomore",
"Junior","Junior","Lab Tech","Lab Tech","Senior","Senior","Baccalauriate",
"Graduate","Grad. Student","Grad. Student","Doctor","Doctor","Professor",
"Professor","Ph.D.","Researcher","Researcher","Genius","Genius",
"Nobel Winner","Nobel Winner","Galileo","Newton","Fermi","Einstein"},

// Guru
{"Believer","Acolyte","Acolyte","Acolyte","Adept","Adept","Adept","Priest",
"Priest","Priest","Priest","Priest","Priest","Priest","Priest",
"Priest","Curate","Curate","Curate","Curate","Curate","Curate","Curate",
"Curate","Curate","Canon","Canon","Canon","Canon","Canon",
"Low Lama","Lama","Lama","Lama","High Lama","Great Lama","Patriarch",
"High Priest","Great Priest","Noble Priest","Grand Poobah","Buddah"},

// Ninja
{"Apprentice","Apprentice","Apprentice","Apprentice",
"Warrior","Warrior","Warrior","Warrior","Warrior","Warrior",
"Swordsman","Swordsman","Swordsman","Swordsman","Swordsman","Swordsman",
"Defender","Defender","Defender","Defender","Defender","Defender",
"Guardian","Guardian","Guardian","Guardian","Guardian","Guardian",
"Noble","Noble","Noble","Noble","Noble","Noble",
"Samuri","Samuri","Samuri","Samuri","Samuri","Samuri",
"Samuri Lord","Samuri Lord"},

// Soldier
{"Street Punk","Street Punk","Recruit","Recruit","Trainee","Trainee",
"Cadet","Cadet","Private","Private","Prv. 1st Class","Prv. 1st Class",
"Corporal","Corporal","Sargeant","Sargeant","Sargeant","Sargeant",
"Master Sarg.","Master Srg.","2nd Lieut.","2nd Lieut.","1st Lieut.",
"1st Lieut.","Captain","Captain","Captian","Captain","Major","Major",
"Major","Major","Lt. Col.","Lt. Col.","Lt. Col","Lt. Col.","Colonel",
"Colonel","Colonel","Colonel","Hero","Hero"},

// Wanderer
{"Gallant","Keeper","Keeper","Keeper","Keeper","Keeper","Keeper","Keeper",
"Keeper","Keeper","Protector","Protector","Protector","Protector","Protector",
"Protector","Protector","Protector","Defender","Defender","Defender",
"Defender","Defender","Defender","Defender","Defender","Warder","Warder",
"Warder","Warder","Warder","Warder","Warder","Warder","Warder","Gauardian",
"Chevalier","Justiciar","Paladin","High Lord","High Lord","High Lord"},

// Con-Artist
{"Street Scum","Street Scum","Street Scum","Street Scum",
"Fingers","Fingers","Fingers","Fingers","Fingers","Fingers",
"Thief","Thief","Thief","Thief","Thief","Thief",
"Hustler","Hustler","Hustler","Hustler","Hustler","Hustler",
"Con","Con","Con","Con","Con","Con","Con","Con","Con","Con",
"Pro","Pro","Pro","Pro","Pro","Pro","Pro","Pro","Ice","Ice"},
 
// Thief
{"Apprentice","Footpad","Cutpurse","Robber","Burglar","Filcher","Sharper",
"Magsman","Common Rogue","Rogue","Rogue","Rogue","Rogue","Rogue","Rogue",
"Rogue","Rogue","Rogue","Master Rogue","Expert Rogue","Senior Rogue",
"Chief Rogue","Prime Rogue","Low Thief","Thief","Thief","Thief",
"Thief","Thief","Thief","Thief","Thief","Thief","High Thief","Master Thief",
"Executioner","Low Assassin","Assassin","HighAssassin","Guildsmaster",
"Guildsmaster","Guildsmaster"},

// Test
{"Loser","Loser","Bubble","Bubble","Frisbee","Frisbee","Spoon","Spoon",
"Silly","Silly","Warlord","Warlord","Plastic","Plastic","Plan9","Plan9",
"AliceB","AliceB","Maven","Maven","Byron","Byron","Milton","Milton",
"IBM","IBM","ttyp4","ttyp4","Ularn","Ularn","Dice","Dice","Raoul","Raoul",
"Ghost","Ghost","Blegga","Blegga","Free","Free","Association","Association"}};



integer    player_exp[MAX_PLAYER_LEVEL+1] = {
    0,10,20,40,80,140,220,290,370,500,
    600,800,1100,1500,2000,2600,3300,4100,5000,6000,
    7200,8800,11200,14400,19200,24400,30000,36000,42400,49000,
    64000,81000,100000,121000,144000,169000,196000,225000,256000,300000,
    400000,750000,9999999};

real       acc_exp = 0.0; //{ Accumulator for fractional exp}
dtype      bare_hands = "1d2";
integer    char_row = 0;
integer    char_col = 0;
integer    com_val;
integer    pclass = 0;
vtype      sex_type = "FemaleMale  ";

/*        {Race   STR,INT,WIS,DEX,CON,CHR,
                Ages, heights, and weights,
                Racial Bases for: bdis,bsrh,bstl,bperc,bbth,bbthb,bdev,bsav,
                bhitdie,binfra, choice-classes }
{ Class choice bit string goes (from MSB to LSB): Thief, Con-Artist,
  Wanderer, Soldier, Ninja, Guru, Scientist, Wrestler }*/
race_type  race[MAX_RACES+1] = {
    {"Elite",1,1,1,1,1,1,20,30,72,6,180,25,66,4,120,20,1.40,
     15,10, 3,10,15,15,10,5,6,0,0xFF},
    {"Hefty",5,0,0,0,1,0,19,30,72,6,210,25,66,4,150,20,1.30,
     5, 5, 2, 5,20,-5,10,10,5,0,0xFF},
    {"Mad",0,5,0,1,0,0,25,45,60,6,150,25,54,4,100,20,1.00,
     5, 5, 2, 5,-5, 5,20,5,2,0,0xFF},
    {"Wise",0,1,5,0,0,0,35,50,70,6,150,25,66,4,100,20,1.20,
     5,15, 2, 5,-5, 5,10,5,4,0,0xFF},
    {"Lucky",0,0,1,5,0,0,18,30,72,6,150,25,66,4,100,20,1.40,
     20,10, 2,15, 5,20,10,15,6,0,0xFF},
    {"Healthy",1,0,0,0,5,0,20,30,72,6,150,25,66,4,100,20,1.60,
     5, 5, 2,10,10, 5,10,5,8,0,0xFF},
    {"Sexy",0,0,0,1,0,5,17,25,72,6,150,25,66,4,100,20,1.40,
     5, 5, 2, 5, 5, 5,10,20,6,0,0xFF},
    {"Alien",3,3,-3,3,3,-3,100,1000,72,6,150,25,66,4,100,20,1.40,
     5, 5, 3,10,15,10,30,10,6,8,0xBB}
};

background_type    background[MAX_BACKGROUND+1] = {
{"You are the illegitimate and unacknowledged child ", 10, 1, 2,-25},
{"You are the illegitimate but acknowledged child ", 20, 1, 2,-15},
{"You are the only child ", 50, 1, 2, 10},
{"You are the favorite child ", 100, 1, 2,10},
{"of a Drunken Gardener.  ", 10, 2, 3, -20},
{"of a Social Worker.  ", 30, 2, 3, 20},
{"of a Policeman.  ", 50, 2, 3, 40},
{"of a Businessman.  ", 70, 2, 3, 55},
{"of a Doctor.  ", 80, 2, 3, 70},
{"of a Programming Analyist.  ", 90, 2, 3, 40},
{"of a Senator.  ", 100, 2, 3, 90},
{"You have spent years in juvanile hall.  ", 10, 3,50,-30},
{"You are a credit to the family.  ", 80, 3,50,5},
{"You graduated first in your class.  ", 100, 3,50, 30},

{"You are the illegitimate and unacknowledged child ", 10, 4, 5,-25},
{"You are the illegitimate but acknowledged child ", 20, 4, 5,-15},
{"You are the strongest child ", 80, 4, 5, 10},
{"You are the favorite child ", 100, 4, 5,10},
{"of a Vacuum Cleaner Salesman.  ", 10, 5, 6,-10},
{"of a Pro-Wrestler.  ", 60, 5, 6,50},
{"of a Lawyer.  ", 70, 5, 6,20},
{"of a Soldier.  ", 80, 5, 6, 10},
{"of a Philosopher.  ", 90, 5, 6, 15},
{"of a Govenor.  ", 100, 5, 6, 70},
{"You've owned three street gangs.  ", 10, 6,50,-30},
{"You are a credit to the family.  ", 90, 6,50,5},
{"You've never lost a wrestling match!  ", 100, 6,50, 50},

{"You are the illegitimate and unacknowledged child ", 10, 7, 8,-25},
{"You are the strangest child ", 80, 7, 8, 10},
{"You are the favorite child ", 100, 7, 8,20},
{"of a Bartender.  ", 10, 8, 9,0},
{"of a Football Coach.  ", 30, 8, 9,5},
{"of a Unix Programmer.  ", 50, 8, 9, 10},
{"of a Scientist.  ", 80, 8, 9, 30},
{"of a Doctor.  ", 100, 8, 9, 40},
{"A fusion experiment of your's has destroyed a small town.  ",5,9,54,-30},
{"A biology experiment of your's unleashed killer tomatoes.  ",10,9,54,-30},
{"You are a credit to society.  ", 80, 9, 54,30},
{"You have won a nobel prize.  ", 100, 9, 54,50},

{"You are one of several children of a ", 50,10,11, -5},
{"You are the only child of a ", 100,10,11,5},
{"Gardener.  ", 10,11, 12,5},
{"Tavern Owner.  ", 20,11, 12, -10},
{"Political Analyist.  ", 30,11, 12, 20},
{"Steel Worker.  ", 40,11, 12, 20},
{"Real Estate Agent.  ",50,11, 12, 20},
{"Wanderer.  ", 60,11, 12, 65},
{"Theologist.  ", 70,11, 12, 75},
{"Guru.  ", 100, 11, 12, 90},
{"Your wisdom has led you only to sleazy taverns.  ",10,12,50,-30},
{"You are a credit to your family.  ", 60, 12, 50,20},
{"You have achieved oneness with yourself.  ", 100, 12, 50,30},

{"You are one of several children of a  ", 85,13,14, -5},
{"You are the only child of a  ", 100,13,14,5},
{"Thief.  ",20,14, 15,-30},
{"Chimney Sweep. ", 50,14, 15, 10},
{"Con-Artist.  ", 75,14, 15, 0},
{"VMS Programmer.  ", 95,14, 15, 20},
{"Millionaire.  ", 100,14, 15, 75},
{"Your luck may have have run out!  ",20,15,50,-10},
{"You are the hero of your town.  ", 80, 15, 50,50},
{"Your luck has made you a fortune!  ", 100, 15, 50,100},


{"You are the proud child of a ", 50,16,17,0},
{"You are the only child of a ", 100,16,17,0},
{"Hypocondriac.  ", 20,17,18, -10},
{"Prison Guard.  ", 30,17,18, 0},
{"Politician.  ", 50,17,18, 40},
{"Dentist.  ", 70,17,18, 60},
{"Doctor.  ", 90,17,18, 80},
{"Gold Medalist.  ", 100,17,18,80},
{"You can out drink a rhino.  ", 15,18,50,-20},
{"You are a credit to the family.  ", 85,18,50,0},
{"Medical science is in awe of your health.  ", 100,18,50,50},

{"You are the adopted child of a " , 25,19,20,-10},
{"You are the cutest child of a " ,60,19,20,30},
{"You are the only child of a ", 100,19,20,40},
{"Farmer.  ", 10,20,21, -10},
{"Hockey player.  ", 30,20,21, 30},
{"Magazine Publisher.  ", 50,20,21, 60},
{"Author.  ", 70,20,21, 60},
{"Used Car Salesman.  ", 95,20,21, -10},
{"Billionaire.  ", 100,20,21,100},
{"Your mother sold all your nude baby pictures.  ", 20,21,58,-10},
{"You are a credit to your family.  ", 85,21,58,10},
{"You are society's sex model.  ", 100,21,58,80},


{"You are the rejected child of a ", 10,22,23,-20},
{"You are the confused child of a ", 80,22,23,30},
{"You are the proud child of a ", 100,22,23, 50},
{"Jarwangian Thief.  ", 20,23,24, -40},
{"Jarwangian Soldier.  ", 50,23,24,10},
{"Jarwangian Scientist.  ", 90,23,24, 30},
{"Jarwangian Diplomat.  ", 100,23,24, 50},
{"You have made many enemies among the humans.  ",20,24,62,-30},
{"You are a stable member in the human community.  ", 85,24,62,20},
{"You are a favorite alien of many humans.  ", 100,24,62,50},

{"You have dark brown eyes, ", 20,50,51,-4},
{"You have brown eyes, ", 60,50,51,0},
{"You have hazel eyes, ", 70,50,51,1},
{"You have green eyes, ", 80,50,51,3},
{"You have blue eyes, ", 90,50,51,5},
{"You have blue-gray eyes, ", 100,50,51,-6},
{"straight ", 70,51,52,0},
{"wavey ", 90,51,52,1},
{"curly ", 100,51,52,3},
{"black hair, ", 30,52,53,1},
{"brown hair, ", 70,52,53,3},
{"auburn hair, ", 80,52,53,-3},
{"red hair, ", 90,52,53,4},
{"blonde hair, ", 100,52,53,-1},
{"and a very dark complexion.", 10,53,-1,1},
{"and a dark complexion.", 30,53,-1,3},
{"and an average complexion.", 80,53,-1,-3},
{"and a fair complexion.", 90,53,-1,4},
{"and a very fair complexion.", 100,53,-1,5},

{"You have small beady eyes, ", 30,54,55,0},
{"You have brown eyes, ", 60,54,55,0},
{"You have blue eyes, ", 90,54,55,0},
{"You have glowing red eyes, ", 100,54,55,0},
{"tossled ", 50,55,56,0},
{"straight ", 75,55,56,0},
{"wavey ", 100,55,56,0},
{"grey hair, and a fair complexion.", 10,56,-1,0},
{"brown hair, and a fair complexion.", 30,56,-1,0},
{"white hair, and a fair complexion.",80,56,-1,0},
{"silver hair, and a fair complexion.", 100,56,-1,0},

{"You have alluring eyes, ", 20,58,59,0},
{"You have mesmerising eyes, ", 40,58,59,0},
{"You have blue eyes, ", 60,58,59,0},
{"You have dark brown eyes, ", 80,58,59,0},
{"You have nice eyes, ", 100,58,59,0},
{"flowing ", 30,59,60,0},
{"wavey ", 60,59,60,0},
{"curly ", 100,59,60,0},
{"black hair, ", 30,60,61,0},
{"brown hair, ", 70,60,61,0},
{"auburn hair, ", 80,60,61,0},
{"red hair, ", 90,60,61,0},
{"blonde hair, ", 100,60,61,0},
{"and a dark complexion.", 33,61,-1,0},
{"and a smooth complexion.", 66,61,-1,0},
{"and a tanned complexion.", 100,61,-1,0},

{"You have orange eyes, ", 33,62,63,0},
{"You have glowing eyes, ", 66,62,63,0},
{"You have very large eyes, ", 100,62,63,0},
{"straight ", 33,63,64,0},
{"wavey ", 66,63,64,0},
{"mottled ", 100,63,64,0},
{"purple hair, ", 33,64,65,0},
{"orange hair, ", 66,64,65,0},
{"blue hair, ", 100,64,65,0},
{"and a dark complexion.", 33,65,-1,0},
{"and a smooth complexion.", 66,65,-1,0},
{"and a plastic complexion.", 100,65,-1,0}
};

//{ Buying and selling adjustments for character race VS store owner race }

real       rgold_adj[MAX_CLASS+1][MAX_CLASS+1] = {
/*StoreOwner:    {  Wrs,  Sci,  Gru,  Nnj,  Sol,  Wnd,  Con,  Thf  Test}*/

/*Wrestler   */  {-0.08, 0.06, 0.02,-0.04,-0.02, 0.02,-0.10, 0.00, 0.00},
/*Scientist  */  { 0.04,-0.08, 0.06, 0.02, 0.00, 0.04,-0.04,-0.04, 0.00},
/*Guru       */  { 0.00, 0.02,-0.04, 0.02, 0.04,-0.06, 0.00,-0.04, 0.00},
/*Ninja      */  {-0.02, 0.00,-0.02,-0.06,-0.04, 0.00,-0.02, 0.00, 0.00},
/*Soldier    */  {-0.02, 0.00, 0.04,-0.02,-0.08, 0.02,-0.04, 0.00, 0.00},
/*Wanderer   */  { 0.02, 0.04,-0.08,-0.04, 0.00,-0.08,-0.04,-0.04, 0.00},
/*Con-Artist */  { 0.10, 0.08, 0.00, 0.08, 0.08, 0.08, 0.00, 0.06, 0.08},
/*Thief      */  { 0.06, 0.06, 0.00, 0.06, 0.06, 0.06,-0.02, 0.00, 0.06},
/*Test       */  { 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00}};


//{ Classes...}

class_type class[MAX_CLASS+1] = {
//Class         Exp   HD Dis Src Stl Per Bth Bhb Wrd Sav  S  I  W  D  C  C sk#
{"Wrestler"    ,0.10, 15, 10, 10,  0,  5, 45, 10, -5, 20, 4,-1,-1, 1, 3,-1, 0},
{"Scientist"   ,0.50,  2, 10, 10,  2, 10, 15, 20, 10, 20,-3, 3, 1, 1, 0, 0, 1},
{"Guru"        ,0.30,  4,  8, 10,  2, 30, 30, 10,  5, 25,-1,-1, 3,-1, 2, 2, 3},
{"Ninja"       ,0.10, 10, 15, 22,  4, 25, 40, 45,  0, 40, 2, 1, 2, 3, 0,-1, 0},
{"Soldier"     ,0.30,  8, 10, 15,  3, 20, 35, 50,  5, 25, 2, 2, 1, 2, 1, 1, 2},
{"Wanderer"    ,0.10,  8,  8, 10,  2, 15, 45, 35,  0, 20, 1,-1, 2, 1, 1, 1, 4},
{"Con-Artist"  ,0.50,  6, 13, 10,  2, 15, 30, 30,  0, 25, 2, 0, 0, 2, 1, 3, 5},
{"Thief"       ,0.30,  8, 15, 15,  3, 15, 30, 30,  0, 25, 3, 0, 0, 2, 2, 1, 6},
{"Journalist"  ,0.20,  6, 10, 10,  3, 20, 20, 30,  0, 25, 0, 3, 0, 2, 0, 0, 7}
};

skill_type    skill_list[MAX_SKILLS+1];

treasure_type    mush = {"& Can~ of Beans and Weenies" ,80,',',0x00000000,
			 2400, 0, 308, 1, 1,0, 0, 0, 0, "0d0" , 1};

//{ Each type of character starts out with a lots of provisions...
//  NOTE: the the entries refer to array elements of INVENTORY_INIT array}
byteint    player_init[MAX_CLASS+1][9] = {
/* Wrestler   */  {1,60,17,40,71,69,120,97},   
/* Scientist  */  {1,60,6,39,70,63,115,106},   
/* Guru       */  {1,60,11,39,70,63,116,110},
/* Ninja      */  {1,60,34,44,70,82,120,97},   
/* Soldier    */  {1,60,48,53,76,65,115,106},  
/* Wanderer   */  {1,60,11,39,70,63,116,110},  
/* Con-Artist */  {1,60,6,43,70,82,117,141},
/* Thief      */  {1,60,6,43,70,82,117,141}, 
/* Test       */  {1,60,6,41,70,63,106,107}
};


integer    berz_y[9] = {-99,0,-1,-1,-1,0,1,1,1};
integer    berz_x[9] = {-99,-1,-1,0,1,1,1,0,-1};

    //{ Following are store definitions   }
integer    office_char_row;
integer    office_char_col;
boolean    exited_office;

owner_type owners[MAX_STORES+1][MAX_TOWNS+1] = {{},

{{},
 {"Penny Preatty       (Wanderer)      K-Mart",            1,0.04,0.40,6},
 {"Leisure Suit Larry  (Scientist)     K-Mart",            1,0.06,0.40,2},
 {"Charlie Yatchet     (Con-Artist)    K-Mart",            1,0.08,0.45,7},
 {"W.C. Meadows        (Guru)          K-Mart",            1,0.10,0.45,3},
 {"John                (Guitar)        K-Mart",            1,0.12,0.50,9},
 {"Ringo               (Drummer)       K-Mart",            1,0.15,0.50,9},
 {"Paul                (Bass)          K-Mart",            1,0.20,0.55,9},
 {"George              (Sitar)         K-Mart",            1,0.30,0.55,9}},

{{},
 {"The Hulkster        (Wrestler)      Leather & Chains",   1,0.06,0.40,1},
 {"Crazy Eddie         (Soldier)       Leather & Chains",   1,0.08,0.40,5},
 {"Steel-Fist Thelma   (Wrestler)      Leather & Chains",   1,0.10,0.45,1},
 {"James Bondage       (Wrestler)      Leather & Chains",   1,0.12,0.45,1},
 {"Major Disaster      (Soldier)       Leather & Chains",   1,0.15,0.50,5},
 {"Corporal Punishment (Soldier)       Leather & Chains",   1,0.20,0.50,5},
 {"Olga                (Wrestler)      Leather & Chains",   1,0.30,0.55,1},
 {"Cool Hand Fluke     (Soldier)       Leather & Chains",   1,0.40,0.55,5}},

{{},
 {"Chainsaw Mike       (Soldier)       Weapon Shop",       1,0.06,0.40,5},
 {"Samuri Sven         (Ninja)         Weapon Shop",       1,0.08,0.40,4},
 {"Jon Wane            (Soldier)       Weapon Shop",       1,0.10,0.45,5},
 {"The Man From Aunt   (Soldier)       Weapon Shop",       1,0.12,0.45,5},
 {"Killroy             (Ninja)         Weapon Shop",       1,0.15,0.50,4},
 {"Sargent Granite     (Soldier)       Weapon Shop",       1,0.20,0.50,5},
 {"Col. Mustardseed    (Soldier)       Weapon Shop",       1,0.30,0.55,5},
 {"Fluffy              (Teddy Bear)    Weapon Shop",       1,0.40,0.55,9}},

{{},
 {"Shari the Humble    (Guru)          Temple",            1,0.04,0.40,3},
 {"Graceful Gretchen   (Wanderer)      Temple",            1,0.06,0.40,6},
 {"Cosmo the Enlightened  (Guru)       Temple",            1,0.08,0.45,3},
 {"Elvis               (The King)      Temple",            1,0.10,0.45,9},
 {"Elron Cupboard      (Guru)          Temple",            1,0.12,0.50,3},
 {"Tammy Fay Bacon     (Guru)          Temple",            1,0.15,0.50,3},
 {"Hal 9000-B          (Computer)      Temple",            1,0.20,0.55,9},
 {"Okra Winfreid       (Guru)          Temple",            1,0.30,0.55,3}},

{{},
 {"Pop Poolstone       (Scientist)     Bar and Grill",     1,0.04,0.40,2},
 {"Benny the Wino      (Ninja)         Bar and Grill",     1,0.06,0.40,6},
 {"Nuke-Brained Nick   (Con-Artist)    Bar and Grill",     1,0.08,0.45,7},
 {"Yo-Gurt             (Guru)          Bar and Grill",     1,0.10,0.45,3},
 {"Hash-Berry          (Ninja)         Bar and Grill",     1,0.12,0.50,4},
 {"Mike, Ike, and Jim  (Con-Artists)   Bar and Grill",     1,0.15,0.50,7},
 {"Jabba the Pizza Hut (Scientist)     Bar and Grill",     1,0.20,0.55,2},
 {"Donald McRonald     (Ninja)         Bar and Grill",     1,0.30,0.55,4}},

{{},
 {"Dr. StrangeLoaf     (Scientist)     Alien Artifacts",   1,0.06,0.40,2},
 {"Missing Linke       (Guru)          Alien Artifacts",   1,0.08,0.40,3},
 {"Professor X         (Scientist)     Alien Artifacts",   1,0.10,0.45,2},
 {"Chewy Bacon         (Scientist)     Alien Artifacts",   1,0.12,0.45,2},
 {"Mr. Spot            (Guru)          Alien Artifacts",   1,0.15,0.50,3},
 {"E.Z.                (Scientist)     Alien Artifacts",   1,0.20,0.50,2},
 {"Ham Salad           (Scientist)     Alien Artifacts",   1,0.30,0.55,2},
 {"Mr. Dataset         (Con-Artist)    Alien Artifacts",   1,0.40,0.55,7}},

{{},
 {"Lt. Wharf           (Soldier)       Black Market",      1,0.30,0.50,5},
 {"The Butcher         (Thief)         Black Market",      1,0.35,0.50,8},
 {"Smith               (Con-Artist)    Black Market",      1,0.40,0.55,7},
 {"Captain Quirk       (Soldier)       Black Market",      1,0.50,0.55,5},
 {"Guido               (Thief)         Black Market",      1,0.60,0.60,8},
 {"Grandma Wormtongue  (Con-Artist)    Black Market",      1,0.70,0.60,7},
 {"Sun-Tsu             (Soldier)       Black Market",      1,0.80,0.70,5},
 {"The Butcher         (Thief)         Black Market",      1,0.90,0.70,8}},

{{},
 {"Ginsing Gary        (Ninja)         Gun Shop",          1,0.06,0.40,4},
 {"Wilber Samaroo      (Soldier)       Gun Shop",          1,0.08,0.40,5},
 {"Queue               (Scientist)     Gun Shop",          1,0.10,0.45,2},
 {"Mr. Krueger         (Ninja)         Gun Shop",          1,0.12,0.45,4},
 {"Wargha              (Scientist)     Gun Shop",          1,0.15,0.50,2},
 {"Gramdpa Wormtongue  (Con-Artist)    Gun Shop",          1,0.20,0.50,7},
 {"Helga               (Wanderer)      Gun Shop",          1,0.30,0.55,6},
 {"Norma Bates         (Psycho)        Gun Shop",          1,0.40,0.55,9}},

{{},
 {"Big Jake            (Wrestler)      Pro Shop",          1,0.06,0.40,1},
 {"Coach Crawldirt     (Soldier)       Pro Shop",          1,0.08,0.40,5},
 {"Ski-Bunny Betty     (Wanderer)      Pro Shop",          1,0.10,0.45,6},
 {"Mr. Buck Rogers     (Wrestler)      Pro Shop",          1,0.12,0.45,1},
 {"Admiral Skeet       (Soldier)       Pro Shop",          1,0.15,0.50,5},
 {"Bjorn Boring        (Wanderer)      Pro Shop",          1,0.20,0.50,6},
 {"Nadia Comb-an-inch  (Wrestler)      Pro Shop",          1,0.30,0.55,1},
 {"Err Jordan          (Soldier)       Pro Shop",          1,0.40,0.55,5}},

{{},
 {"Mr. Solar           (Scientist)     Computer Store",    1,0.06,0.40,2},
 {"Dr. John Smith      (Scientist)     Computer Store",    1,0.08,0.40,2},
 {"Zapper              (Mad Scientist) Computer Store",    1,0.10,0.45,2},
 {"Bill Grates         (Scientist)     Computer Store",    1,0.12,0.45,2},
 {"Steve Batch Jobs    (Scientist)     Computer Store",    1,0.15,0.50,2},
 {"Donald Canoeth      (Scientist)     Computer Store",    1,0.20,0.50,2},
 {"Jimmy Wayne Todd    (Programmer)    Computer Store",    1,0.30,0.55,2},
 {"Robert Alan Koeneke (Programmer)    Computer Store",    1,0.40,0.55,2}},

{{},
 {"cloister            (Soldier)       Guild",             1,0.06,0.40,5},
 {"Cutpurse Mallone    (Thief)         Guild",             1,0.08,0.40,8},
 {"Lightfingered Lisa  (Con-Artist)    Guild",             1,0.10,0.45,7},
 {"Peg Leg Pete        (Soldier)       Guild",             1,0.12,0.45,5},
 {"Captain Blight      (Soldier)       Guild",             1,0.15,0.50,5},
 {"Russell Fingers     (Con-Artist)    Guild",             1,0.20,0.50,7},
 {"Milo Minderbender   (Soldier)       Guild",             1,0.30,0.55,5},
 {"Six Fingered Louie  (Thief)         Guild",             1,0.40,0.55,8}}};


store_type stores[MAX_STORES+1];


integer    store_choice[MAX_STORES+1][STORE_CHOICES+1] = {
//{ Bogus }
{0},

//{ K-Mart }
{0,6,7,8,9,10,11,28,29,30,31,57,57,57,59,59,59,59,60,60,60,60,64,64,70,81,86},

//{ Leather & Chains }
{0,65,65,65,72,72,73,73,74,76,76,77,77,78,78,79,
80,81,81,82,82,83,83,84,84,85,85},

//{ Weapon Shop }
{0,32,32,33,33,34,34,35,35,36,36,37,37,38,38,
42,42,43,43,44,44,45,45,46,46,154,154},

//{ Temple }
{0,11,11,87,87,88,88,89,90,90,91,91,92,92,93,93,
110,110,111,111,111,112,112,112,113,113,113},

//{ Bar and Grill }
{0,1,1,2,3,4,5,114,115,116,117,118,119,120,121,122,123,
124,135,138,139,148,149,150,151,152,153},

//{ Alien Artifacts }
{0,125,126,127,128,129,130,131,132,133,134,140,155,
125,126,127,128,128,129,130,131,131,132,133,134,140,155},

//{Black Market - non standard inventory}
{0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},

//{Gun Shop}
{0,47,47,48,48,49,49,50,50,51,51,52,52,
53,53,53,54,54,54,55,56,156,156,157,157,158,158},

//{Pro Shop}
{0,12,13,14,15,16,17,17,19,20,21,22,23,24,25,26,27,39,40,41,
63,66,67,68,69,71,75},

//{Computer Store}
{0,94,95,96,97,98,99,100,101,102,103,104,105,
106,107,107,108,108,109,109,136,137,137,
145,145,146,147},

//{Guild}
{0,18,28,29,30,31,58,58,61,61,62,62,102,128,132,133,
141,141,142,142,142,143,143,143,144,144,144}
};


//{ Each store will buy only certain items,based on TVAL }
obj_set    store_buy[MAX_STORES+1] = {
/* Bogus */ {0},
/* K */     {2,3,15,30,32,77,0},
/* L */     {30,31,32,33,34,35,36,0},
/* W */     {21,23,82,84,0},
/* T */     {40,45,91,0},
/* + */     {75,76,80,0},
/* A */     {40,45,55,65,0},
/* B */     {9,10,11,12,19,20,21,23,29,30,31,32,33,34,35,40,45,
	    55,60,65,70,71,75,76,82,84,90,91,92,0},
/* G */     {9,10,11,12,19,20,0},
/* P */     {23,33,0},
/* C */     {29,70,71,90,0},
/* # */     {13,25,92,0}

};

ctype      joblist[10] = {"Bogus","Dish Washer","Boiler Room Worker","Bellhop",
			  "Doorman","Security Guard","Gourmet Chef",
			  "Body Guard","Accountant","Hotel Manager"};

byteint    jobwage[10] = {1,3,5,7,9,11,15,25,40,90};

town_type  townlist[MAX_TOWNS+1] = {
    {"Cheney",10,0},
    {"Seattle",10,0},
    {"Boise",10,6},
    {"Denver",10,12},
    {"Kansas City",10,18},
    {"Chicago",10,24},
    {"Detroit",10,30},
    {"Pittsburgh",10,36},
    {"New York City",50,42}  
};

    //{ Following are treasure arrays and variables   }
treasure_type    object_list[MAX_OBJECTS+1];
boolean    object_ident[MAX_OBJECTS+1];
integer    t_level[MAX_OBJ_LEVEL+1];// :  array [0..] of 

//{ Gold list (All types of gold and gems are defined here) }
treasure_type    gold_list[MAX_GOLD+1] = {
{"nickels", 100,          '$' ,0x00000000, 0,  1,2,0,0,0,0,0,0, " " , 1},
{"arcade tokens",100,     '$' ,0x00000000, 0,  1,2,0,0,0,0,0,0, " " , 1},
{"dimes", 100,            '$' ,0x00000000, 0,  2,2,0,0,0,0,0,0, " " , 1},
{"trinkets",100,          '*' ,0x00000000, 0,  2,3,0,0,0,0,0,0, " " , 1},
{"blank disks",100,       '*' ,0x00000000, 0,  3,3,0,0,0,0,0,0, " " , 1},
{"postage stamps",100,    '$' ,0x00000000, 0,  3,1,0,0,0,0,0,0, " " , 1},
{"loose change", 100,     '$' ,0x00000000, 0,  5,2,0,0,0,0,0,0, " " , 1},
{"pez dispensers" ,100,   '*' ,0x00000000, 0,  5,3,0,0,0,0,0,0, " " , 1},
{"bubble gum", 100,       '*' ,0x00000000, 0,  8,3,0,0,0,0,0,0, " " , 1},
{"gold fillings",100,     '*' ,0x00000000, 0, 10,3,0,0,0,0,0,0, " " , 1},
{"foreign bills", 100,    '$' ,0x00000000, 0, 10,1,0,0,0,0,0,0, " " , 1},
{"old comic books",100,   '*' ,0x00000000, 0, 15,3,0,0,0,0,0,0, " " , 1},
{"$1 bills",100,          '$' ,0x00000000, 0, 15,1,0,0,0,0,0,0, " " , 1},
{"food stamps",100,       '$' ,0x00000000, 0, 15,1,0,0,0,0,0,0, " " , 1},
{"small bills",100,       '$' ,0x00000000, 0, 20,1,0,0,0,0,0,0, " " , 1},
{"silicon chips" , 100,   '*' ,0x00000000, 0, 20,3,0,0,0,0,0,0, " " , 1},
{"chic jewelry" ,100,     '*' ,0x00000000, 0, 25,4,0,0,0,0,0,0, " " , 1},
{"digital watches",100,   '*' ,0x00000000, 0, 30,3,0,0,0,0,0,0, " " , 1},
{"car stereos" , 100,     '*' ,0x00000000, 0, 50,4,0,0,0,0,0,0, " " , 1},
{"large bills",100,       '$' ,0x00000000, 0, 60,1,0,0,0,0,0,0, " " , 1},
{"illegal drugs", 100,    '*' ,0x00000000, 0, 70,3,0,0,0,0,0,0, " " , 1},
{"uncut diamonds",100,    '*' ,0x00000000, 0, 75,3,0,0,0,0,0,0, " " , 1},
{"silver coins",100,      '$' ,0x00000000, 0, 80,2,0,0,0,0,0,0, " " , 1},
{"quarters",100,          '$' ,0x00000000, 0, 80,2,0,0,0,0,0,0, " " , 1},
{"gold coins",100,        '$' ,0x00000000, 0,100,2,0,0,0,0,0,0, " " , 1},
{"gold dust", 100,        '*' ,0x00000000, 0,100,3,0,0,0,0,0,0, " " , 1},
{"stock certificates",100,'$' ,0x00000000, 0,120,1,0,0,0,0,0,0, " " , 1},
{"alien crystals",100,    '*' ,0x00000000, 0,150,5,0,0,0,0,0,0, " " , 1},
{"diamonds",100,          '*' ,0x00000000, 0,200,3,0,0,0,0,0,0, " " , 1},
{"alien crystals",100,    '*' ,0x00000000, 0,300,5,0,0,0,0,0,0, " " , 1}
};


treasure_type    t_list[MAX_TALLOC+1];
treasure_type    inventory[INVEN_MAX+1];
treasure_type    equipment[EQUIP_MAX+1];// :  array [23..equip_max] of 
treasure_type    temporary_slot;
treasure_type    inventory_init[MAX_INVENTORY_INIT+1];
treasure_type    blank_treasure = {" ",0,' ',0,0,0,0,0,0,0,0,0,0," ",0};
integer    inven_ctr = 0;  //{ Total different obj's }
integer    inven_weight = 0;  //{ Cur carried weight    }
integer    equip_ctr = 0;  //{ Cur equipment ctr }
integer    tcptr;  //{ Cur treasure heap ptr }
 
 
    //{ Following are creature arrays and variables   }
creature_type c_list[MAX_CREATURES+EXTRA_MONSTERS+1];
monster_type  m_list[MAX_MALLOC+1];
integer       m_level[MAX_MONS_LEVEL+1];// :  array [0..] of 
monster_type  blank_monster; //{Blank monster values}
integer       muptr;  //{ Cur used monster ptr  }
integer       mfptr;  //{ Cur free monster ptr  }
integer       mon_tot_mult;  //{ # of repro's of creature  }

//{max 60 chars long}
etype         attack_desc[MAX_ATTACK_DESC+1] = {
    "boguses on you.",
    "hits you.",
    "bites you.",
    "claws you.",
    "stings you.",
    "touches you.",
    "kicks you.",
    "gazes at you.",
    "breathes on you.",
    "spits on you.",
    "makes a horrible wail.",
    "embraces you.",
    "crawls on you.",
    "release a cloud of spores.",
    "begs you for money.",
    "covers you with slime.",
    "crushes you.",
    "tramples you.",
    "drools on you.",
    "random Eddie attacks.",
    "touches you with its tentacles.",
    "head-butts you.",
    "recites poetry at you.",
    "mentally stabs you.",
    "moons you.",
    "comments about your mother.",
    "makes the ground beneath your feet strike you.",
    "shoots you.",
    "chews on you.",
    "makes your brain bleed.",
    "does a ninja kick.",
    "blasts you with an alien device.",
    "surrounds you.",
    "shocks you.",
    "wrestles you to the floor.",
    "does the infamous daysian mind-trick on you.",
    "smacks you but good.",
    "stabs you.",
    "slices and dices you.",
    "sears you with a blast of heat.",
    "turns your own weapon against you.",
    "lip sync's at you.",
    "asks you for directions.",
    "rings a bell.",
    "changes the save file.",
    "is repelled." /*{45}*/
};

//{max 14 chars long}
btype         hit_desc[MAX_HIT_DESC+1] = {
    "bogus",
    "smack around",
    "pound",
    "thwap",
    "hit",
    "wallop",
    "slice",
    "slash",
    "bash",
    "thump",
    "wail on"
};

integer       kill_list[MAX_CREATURES+EXTRA_MONSTERS+1];

    //{ Following are arrays for descriptive pieces   }
atype    colors[MAX_COLORS] = {
    "Amber","Azure","Blue","Blue Speckled","Blue Spotted",
    "Black","Black Speckled","Black Spotted","Brown",
    "Brown Speckled","Brown Spotted","Bubbling",
    "Chartreuse","Clear","Cloudy","Copper","Copper Spotted",
    "Crimson","Cyan","Dark Blue","Dark Green","Dark Red",
    "Ecru","Gold","Gold Spotted","Green","Green Speckled",
    "Green Spotted","Grey","Grey Spotted","Hazy","Indigo",
    "Light Blue","Light Green","Magenta","Metallic Blue",
    "Metallic Red","Metallic Green","Metallic Purple",
    "Misty","Orange","Orange Speckled","Orange Spotted",
    "Pink","Pink Speckled","Plaid","Puce","Purple",
    "Purple Speckled","Purple Spotted","Red","Red Speckled",
    "Red Spotted","Silver","Silver Speckled",
    "Silver Spotted","Smokey","Tan","Tangerine","Topaz",
    "Turquoise","Violet","Vermillion","White",
    "White Speckled","White Spotted","Yellow",
    "Navy Blue","Striped","Maroon","Filmy","Holographic",
    "Polka-Dot","Silly","Bloody"
};

atype    mushrooms[MAX_MUSH] = {
    "Blue","Black","Brown","Copper","Crimson","Dark blue",
    "Dark green","Dark red","Gold","Green","Grey",
    "Light Blue","Light Green","Orange","Pink","Plaid",
    "Purple","Red","Tan","Turquoise","Violet","White",
    "Yellow","Wrinkled","Wooden","Slimey","Speckled",
    "Spotted","Furry"
};

atype    woods[MAX_WOODS] = {
    "Terra-cotta","Frenisium","Rectangular","Not there",
    "Flammable","Icy","Gurgling","Broken",
    "Bubbly","Crispy-crunchy","Deformed","Sluggish",
    "Massy","Fossilized","Plaid flannel","Tacky",
    "Objet-d""art","Very very tiny","Vibrating","Talkative",
    "Half baked","Sauteed","Over easy","Bar-b-queued",
    "MKS unit","Barrel-like","Polymerized","Phenelalenuric",
    "Rabbit-fur","Teak","Edible","Bitchin""",
    "Growing","Lethal","Kinky","Demon-spawn",
    "Daisyian","Scaly","Warm","Soft"
};

atype    metals[MAX_METALS] = {
    "Long","Skinny","Thick","Short","Curved","Notched",
    "Ribbed","Hollow","Heavy","Really big","Maniacal",
    "Cherry flavored","Caffeine free","Frenesium","Flammable",
    "Broken","Deformed","Daisyian","Pulsating","Berzerker",
    "'...---...'","Unguessable","Electronic","Diamond",
    "Unsatisfactory","Massive","Wow! a","Not very good",
    "My favorite","Reagan","RADIOACTIVE!"
};

atype    rocks[MAX_ROCKS] = {
    "Beatles","Agate","Alexandrite","Amethyst","Antlerite",
    "Aquamarine","Argentite","Azurite","Beryl","Bloodstone",
    "Calcite","Carnelian","Coral","Corundum","Cryolite",
    "Diamond","Diorite","Emerald","Flintstones","Fluorite",
    "Gabbro","Garnet","Granite","Gypsum","Hematite","Jade",
    "Jasper","Kryptonite","Lapus lazuli","Pink Floyd",
    "Malachite","Manganite","Marble","Moonstone","Mudstone",
    "Neptunite","Obsidian","Doors","Opulent","Pyrite",
    "Quartz","Quartzite","Rhodonite","Rhyolite","Ruby",
    "Saphire","Sphalerite","Staurolite","Tiger eye","Topaz",
    "Turquoise","Rolling Stones","Bowie" 
};

atype    amulets[MAX_AMULETS] = {
    "Birch","Ceder","Dogwood","Driftwood","Elm wood",
    "Hemlock","Hickory","Mahogany","Maple","Oak","Pine",
    "Redwood","Rosewood","Walnut","Aluminium","Bone","Brass",
    "Bronze","Copper","Iron","Lead","Nickel","Agate",
    "Amethyst","Diamond","Emerald","Flint","Garnet","Jade",
    "Obsidian","Onyx","Opal","Pearl","Quartz","Ruby",
    "Saphire","Tiger eye","Topaz","Turquoise" 
};

tentype  syllables[MAX_SYLLABLES] = {
/*{tentype}*/         "Methods","Methods","Methods",
                      "One way","Two ways","Ways","Many ways",
/*{Noun}*/            "A program","Programs","Programs","Games",
                      "Steps","Two steps","Reasons","Questions",
                      "Problems","Puzzles","Truths","Lies","Sayings",
                      
                      "amuse","kill","scare","sway","buckle",
/*{Verb}*/            "compile","destroy","maim","locate","find",
                      "negate","enhance","help","dismay","surprise",
                      "file","delete","link","separate","repair",
                      
                      "your","many","two","three","four","many",
/*{Adjective}*/       "several","lots of","a lot of","ribbed",
                      "simple","strange","glowing","trapped",
                      "angry","lost","broken","many","your","evil",
                      
                      "friends","enemies","weapons","helms","neighbors",
/*{Plural Noun}*/     "monsters","creatures","aliens","mutants",
                      "friends","traps","eyes","people","junk",
                      "doors","bones","disks","towels","walls","robots" 
};

    //{ Following are variables for the Save Character Routines   }
vtype       finam;
boolean     data_corrupt;
//key_type    key_rec;
 
    //{ Cursor variables, used for cursor positioning }
char       cursor_r[25][12];// :  array [1..24] of varying[10] of char;
integer    curlen_r;
char       cursor_c[81][12];// :  array [1..80] of varying[10] of char;
integer    curlen_c;
integer    cursor_l;
boolean    row_first;
char       cursor_erl[12];// :  varying[10] of char;
char       cursor_erp[12];// :  varying[10] of char;

//{ Misc. Junk Values }

// it looks like a shifted BOSS, but what was it for?
//char       raoul[4] = {'S','B','O','S'}; //  :  array [0..3] of char;

tentype    wall_chr = "###&8#@8@&";      //{ (dun_level mod 10) +1  --> 1-10}
obj_set    open_cave_set = {0,2,3,5,7,8,0};
etype      alpha_set = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";

usernam_type    username;  //{duh...}
integer    wierd_chance;

// new stuff

/* used in get_flags, and other places if I needed them */
obj_set null_obj_set           = {0,0};
obj_set destroyed_by_fire      = {12,20,21,22,30,31,32,36,55,
				  70,71,75,76,80,104,105,0};
obj_set destroyed_by_cold      = {75,76,0};
obj_set destroyed_by_acid      = {12,20,21,22,30,31,32,33,34,
				  35,36,55,70,71,80,104,105,0};
obj_set destroyed_by_lightning = {45,60,65,0};


integer		malloc_calls = 0;
integer		malloc_bytes = 0;
integer		free_calls   = 0;
integer		free_bytes   = 0;
int             game_state;
gid_t           games_gid;
boolean         curses_is_running = false;
boolean		msg_terse;
byteint		record_ctr = 0;
vtype		msg_prev[MAX_MESSAGES+1];
integer		max_score = 20; //	{ # of scores to list }

boolean scoresAreEncrypted      = false;
boolean saveFilesAreEncrypted   = false; 
byteint highScoreKey[8]         = {1,2,3,4,5,6,7,8};
byteint saveFileKey[8]          = {8,7,6,5,4,3,2,1};


/* END FILE  values.h */
