/* variables.h */
/* Ever feel the need for more global vars? */

extern FILE       *tempfile; //{debugging file}
extern boolean     scumuser; //{ used when detecting users who shouldn't play }
extern boolean     putzuser;
extern boolean     validuser;
//    resist_gas : [psect(player$data)] boolean;  {Soon to be a py.flag}
extern integer     max_weight;
extern boolean     is_boss_dead;
extern integer     total_winner_num;
extern boolean     defeated_badguy;
extern boolean     out_of_time;         //{ 100-day time limit flag. -jeb}
extern integer     max_creatures;       //{total # of monsters in mlist}
extern integer     max_objects;         //{total # in objects.dat }
extern integer     inven_init_max;      //{ Size of store inventory }
extern integer     player_max_exp;      //{ Max exp possible    }
extern unsigned    seed;                //{ Contains seed # }
extern unsigned    randes_seed;         //{ For encoding colors }
extern unsigned    town_seed;           //{ Seed for town generator }
extern integer     channel;             //{ I/O channel #   }
extern quad_type   io_bin_pause;        //{ I/O pause time  }
extern integer     cur_height,cur_width;//{ Cur dungeon size}
extern integer     dun_level;   //{ Cur dungeon level   }
extern integer     dun_power;   //{ Cur power of dun level}
extern integer     town_num;    //{ Cur town player is in -RLG}
extern integer     missle_ctr;  //{ Counter for missles }
extern integer     msg_line;    //{ Contains message txt}
extern boolean     msg_flag;    //{ Set with first msg  }
extern boolean     more_flag;   //{ Question -more- on/off -jeb}
extern boolean     wall_flag;   //{ Toggle Neat Wall Paterns. -RLG}
extern vtype       old_msg;     //{ Last message    }
extern boolean     generate;    //{ Generate next level }
extern boolean     death;       //{ True if died    }
extern vtype       died_from;   //{ What killed him }
extern boolean     find_flag;   //{ Used in MORIA   }
extern boolean     reset_flag;  //{ Used in MORIA   }
extern boolean     cave_flag;   //{ Used in GET_PANEL   }
extern boolean     light_flag;  //{ Used in MOVE_LIGHT  }
extern boolean     redraw;      //{ For redraw screen   }
extern integer     stat_column; //{ Column for stats    }
extern unsigned    print_stat;  //{ Flag for stats  }
extern integer     turn;        //{ Cur turn of game    }
extern integer     day;         //{ day counter     -RLG   }
extern boolean     wizard;      //{ Wizard flag }
extern boolean     used_line[24];
extern usernam_type    password1;
extern usernam_type    password2;
extern char	   days[7][30];
extern integer     closing_flag;  //{ Used for closing   }

    //{Bank Stuff} 
extern integer     act_bal;
extern integer     principal;
extern integer     payment_count;
extern real        iod_val, iol_val, danny_cut;
    
    //{ Bit testing array }
extern unsigned    bit_array[33];
 
    //{ External file names; are all located in directory with image  }
extern vtype    BOSS_HOU,BOSS_MOR;
extern vtype    BOSS_MAS,BOSS_TOP;    
extern vtype    BOSS_HLP,BOSS_MON;
extern vtype    BOSS_OBJ,BOSS_LOS;
extern vtype    BOSS_WIZ,BOSS_ANNOY;
extern vtype    BUS_PIC ,QUOTES;
extern vtype    BOSS_INV,SKILLS;
   
    //{  Following are calculated from max dungeon sizes  }
extern integer    max_panel_rows,max_panel_cols;
extern integer    quart_height,quart_width;
extern integer    panel_row,panel_col;
extern integer    panel_row_min,panel_row_max;
extern integer    panel_col_min,panel_col_max;
extern integer    panel_col_prt,panel_row_prt;
 
    //{  Following are all floor definitions  }
extern row_floor	cave[MAX_HEIGHT+1];
extern cave_type    blank_floor;
extern floor_type    dopen_floor;
extern floor_type    lopen_floor;
extern floor_type    corr_floor1, corr_floor2;
extern floor_type    corr_floor3, corr_floor4;
extern floor_type    rock_wall1, rock_wall2;
extern floor_type    rock_wall3, boundry_wall;
extern floor_type    water1, water2, water3;
 
    //{  Following are set definitions    }
extern obj_set    floor_set, wall_set;
extern obj_set    pwall_set, corr_set;
extern obj_set    trap_set, light_set;
extern obj_set	  earth_set;
extern obj_set	  water_set;
extern obj_set    open_cave_set;
extern integer    circle[10];  //{Circle Room}

//{neatness arrays}
extern byteint		key_of[9];
extern byteint		oct_of[10];
extern bytlint		dx_of[10];
extern bytlint		dy_of[10];

    //{ Following are player variables    }
extern player_type    py;
extern btype	player_title[MAX_CLASS+1][MAX_PLAYER_LEVEL+1];
//				  array [1..max_class] of
//				  array [1..max_player_level] of btype;

extern integer    player_exp[MAX_PLAYER_LEVEL+1];
extern real       acc_exp; //{ Accumulator for fractional exp}
extern dtype      bare_hands;
extern integer    char_row;
extern integer    char_col;
extern integer    com_val;
extern integer    pclass;
extern vtype      sex_type;
extern race_type  race[MAX_RACES+1];
extern background_type    background[MAX_BACKGROUND+1];
extern real       rgold_adj[MAX_CLASS+1][MAX_CLASS+1];
extern class_type class[MAX_CLASS+1];

extern skill_type    skill_list[MAX_SKILLS+1];

extern treasure_type    mush;
extern byteint    player_init[MAX_CLASS+1][9];
extern integer    berz_y[9];
extern integer    berz_x[9];

    //{ Following are store definitions   }
extern integer    office_char_row;
extern integer    office_char_col;
extern boolean    exited_office;
extern owner_type owners[MAX_STORES+1][MAX_TOWNS+1];
extern store_type stores[MAX_STORES+1];
extern treasure_type store_door[MAX_DOORS+1];
extern treasure_type building_door[MAX_BDOORS+1];
extern integer    store_choice[MAX_STORES+1][STORE_CHOICES+1];
extern obj_set    store_buy[MAX_STORES+1];
extern ctype      joblist[10];
extern byteint    jobwage[10];
extern town_type  townlist[MAX_TOWNS+1];

    //{ Following are treasure arrays and variables   }
extern treasure_type    object_list[MAX_OBJECTS+1];
extern boolean    object_ident[MAX_OBJECTS+1];
extern integer    t_level[MAX_OBJ_LEVEL+1];// :  array [0..] of 
extern treasure_type    gold_list[MAX_GOLD+1];
extern treasure_type    t_list[MAX_TALLOC+1];
extern treasure_type    inventory[INVEN_MAX+1];
extern treasure_type    equipment[EQUIP_MAX+1];// :  array [23..equip_max] of 
extern treasure_type    temporary_slot;
extern treasure_type    inventory_init[MAX_INVENTORY_INIT+1];
extern treasure_type    blank_treasure;
extern integer    inven_ctr;  //{ Total different obj's }
extern integer    inven_weight;  //{ Cur carried weight    }
extern integer    equip_ctr;  //{ Cur equipment ctr }
extern integer    tcptr;  //{ Cur treasure heap ptr }
 
    //{ Following are feature objects defined for dungeon }
extern treasure_type    trap_lista[MAX_TRAPA+1];
extern treasure_type    trap_listb[MAX_TRAPB+1];
extern treasure_type    blk_mkt_trap; //{Black Market trap}
extern treasure_type    scare_monster; //{Special trap}
extern treasure_type    rubble;
extern treasure_type    door_list[3+1];
extern treasure_type    up_stair[MAX_STAIR+1];
extern treasure_type    down_stair[MAX_STAIR+1];
 
    //{ Following are creature arrays and variables   }
extern creature_type c_list[MAX_CREATURES+EXTRA_MONSTERS+1];
extern monster_type  m_list[MAX_MALLOC+1];
extern integer       m_level[MAX_MONS_LEVEL+1];// :  array [0..] of 
extern monster_type  blank_monster; //{Blank monster values}
extern integer       muptr;  //{ Cur used monster ptr  }
extern integer       mfptr;  //{ Cur free monster ptr  }
extern integer       mon_tot_mult;  //{ # of repro's of creature  }
extern etype         attack_desc[MAX_ATTACK_DESC+1];
extern btype         hit_desc[MAX_HIT_DESC+1];
extern integer       kill_list[MAX_CREATURES+EXTRA_MONSTERS+1];

    //{ Following are arrays for descriptive pieces   }
extern atype    colors[MAX_COLORS];
extern atype    mushrooms[MAX_MUSH];
extern atype    woods[MAX_WOODS];
extern atype    metals[MAX_METALS];
extern atype    rocks[MAX_ROCKS];
extern atype    amulets[MAX_AMULETS];
extern tentype  syllables[MAX_SYLLABLES];
 
    //{ Following are variables for the Save Character Routines   }
extern vtype       finam;
extern boolean     data_corrupt;
//extern key_type    key_rec;
 
    //{ Cursor variables, used for cursor positioning }
extern char       cursor_r[25][12];// :  array [1..24] of varying[10] of char;
extern integer    curlen_r;
extern char       cursor_c[81][12];// :  array [1..80] of varying[10] of char;
extern integer    curlen_c;
extern integer    cursor_l;
extern boolean    row_first;
extern char       cursor_erl[12];// :  varying[10] of char;
extern char       cursor_erp[12];// :  varying[10] of char;
extern char       raoul[4];//  :  array [0..3] of char;
extern tentype    wall_chr;
extern usernam_type    username;  //{duh...}
extern integer    wierd_chance;

// new stuff
extern	integer malloc_calls;
extern	integer malloc_bytes;
extern	integer	free_calls;
extern	integer	free_bytes;
extern  int game_state;
extern	boolean curses_is_running;
extern  gid_t   games_gid;
extern	boolean		msg_terse;
extern	byteint		record_ctr;
extern  vtype		msg_prev[MAX_MESSAGES+1];
extern	integer		max_score; //	{ # of scores to list }

extern etype alpha_set;

extern obj_set null_obj_set;
extern obj_set destroyed_by_fire;
extern obj_set destroyed_by_cold;
extern obj_set destroyed_by_acid;
extern obj_set destroyed_by_lightning;

extern  boolean scoresAreEncrypted;
extern  boolean saveFilesAreEncrypted;

extern  byteint highScoreKey[8];
extern  byteint saveFileKey[8];
/* END FILE  variables.h */
