/* wierd.c */
/**/

#include "boss.h"
#include "main.h"

#define  MAX_WIERD  18

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

integer query_max_wierd()
{
  return MAX_WIERD;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void random_wierdness(integer wierd_type, boolean force_wierd)
{

  integer  i1,i2,i3, y,x;
  integer  centerx,centery;
  real     r,theta;
  integer  scramble[6+1];
  boolean  was_wierd;
  vtype    jstr;

  if (putzuser) {
    mess_with_mind();
  }

  do {
    was_wierd = true;
    if (wierd_type == 0) {
      wierd_type = randint(MAX_WIERD);
    }

    switch (wierd_type) {

    case 1: case 2: case 3:
      read_text_data(0,QUOTES);
      break;
      
    case 4: 
      if ((randint(1000) > 1) && (is_boss_dead == false)) {
	was_wierd = false;
      } else {
	msg_print("Extra! Extra! Read all about it!");
	msg_print("The BOSS has learned of your attempts to defeat him.");
	msg_print("Due to the stress this causes him, he has had");
	msg_print("a cardiac arrest and has died.  You are a...");
	msg_print("***TOTAL WINNER***");
	total_winner_num++;
	prt_winner();
	msg_print("");
	if (randint(3) == 3) {
	  is_boss_dead = true;
	} else {
	  /*  {gee, that was fun.  --jeb} */
	  total_winner_num--;
	  msg_print("Just kidding!!!");
	  msg_print("Psych!!!");
	  msg_print("The BOSS lives!");
	  msg_print("");
	  draw_cave();
	}
      }
      break;
      
    case 5:
      msg_print(" ");
      i1 = wierd_chance*MAX_WIERD*3000;
      sprintf(jstr, "You know, there's a random one in %ld", i1);
      msg_print(jstr);
      msg_print("chance that you will just spontaneously win the game.");
      msg_print(" ");
      msg_print("No, really.  It''s true.");
      break;
      
    case 6:
      msg_print("Just because you're not paranoid,");
      msg_print("doesn't mean that they're not out to get you!");
      msg_print("In fact, we can assure you that they *are* out");
      msg_print("to get you.");
      for (i1 = 1; i1 <= 3; i1++) {
	y = char_row;
	x = char_col;
	summon_monster(&y,&x,false);
      }
      creatures(false);
      prt_chp();
      break;

    case 7:
      msg_print("Suddenly, Dirty Harry pops out from out of nowhere");
      msg_print("He says, \"Tag! you're it!\".  You say \"ouch.\"");
      if ((randint(2) == 1) && (dun_level != 0)) {
	msg_print("He says, \"I'll see you back in town...\"");
      } else {
	msg_print("Better watch your back...");
      }
      msg_print("You feel somewhat damaged.");
      take_hit(damroll("1d10"),"Dirty Harry");
      prt_chp();
      break;

    case 8:
      msg_print("You are hit on the noggin by a falling chunk of stone.");
      if (randint(2) == 1) {
	i1 = randint(MAX_SKILLS);
	skill_list[i1].learned = false;
	msg_print("Your head hurts.  You feel like you may have forgotten something.");
	msg_print("A voice says \"Psst, hey you... Check your books.\"");
      } else {
	take_hit(damroll("1d15"),"a falling rock");
      }
      break;

    case 9:
      msg_print("You feel your soul plummet to the depths of hell.");
      py.misc.max_lev += randint(py.misc.lev);
      if (py.misc.max_lev > townlist[town_num].max_depth) {
	py.misc.max_lev = townlist[town_num].max_depth;
      }
      break;

    case 10:
      msg_print(" ");
      msg_print("Something strange just happened.");
      msg_print("But we're not telling...");
      if (!strcmp(py.misc.sex, "Female")) {
	strcpy(py.misc.sex, "Male");
	switch (randint(7)) {
	case 1: strcpy(py.misc.name,  "Herve Villichez");   break;
	case 2: strcpy(py.misc.name,  "The Third Amigo");   break;
	case 3: strcpy(py.misc.name,  "Rasputin");          break;
	case 4: strcpy(py.misc.name,  "Rassilon");          break;
	case 5: strcpy(py.misc.name,  "Dent Arthur Dent");  break;
	case 6: strcpy(py.misc.name,  "Ford Prefect");      break;
	case 7: strcpy(py.misc.name,  "Slartibartfast");    break;
	}
      } else {
	strcpy(py.misc.sex, "Female");
	switch (randint(7)) {
	case 1: strcpy(py.misc.name,  "Elena Redlips");     break;
	case 2: strcpy(py.misc.name,  "Tricia McMillan");   break;
	case 3: strcpy(py.misc.name,  "Ginger Rogers");     break;
	case 4: strcpy(py.misc.name,  "Barbarella");        break;
	case 5: strcpy(py.misc.name,  "Dale Arden");        break;
	case 6: strcpy(py.misc.name,  "Elvira, Mistress of the dark"); break;
	case 7: strcpy(py.misc.name,  "Misery Chastain");   break;
	}
      }
      break;

    case 11: 
      if (randint(100) > 20) {
	was_wierd = false;
      } else {
	msg_print("Suddenly and without warning, you are enveloped in an");
	msg_print("Energy Vortex!!!!!");
	//with py.stat do;
	scramble[1] = PS.str;     /*{scramble the player's stats. }*/
	scramble[2] = PS.dex;     /*{but reset the new currents to}*/
	scramble[3] = PS.con;     /*{be restored.            --jeb}*/
	scramble[4] = PS.int_;
	scramble[5] = PS.wis;  
	scramble[6] = PS.chr;
	for (i1 = 1; i1 <= 6; i1++) {
	  i2 = randint(6);
	  i3 = scramble[i1];
	  scramble[i1] = scramble[i2];
	  scramble[i2] = i3;
	}
	PS.str  = scramble[1];       PS.int_ = scramble[2];
	PS.wis  = scramble[3];       PS.dex  = scramble[4];
	PS.con  = scramble[5];       PS.chr  = scramble[6];
	PS.cstr = PS.str;           PS.cdex  = PS.dex;
	PS.ccon = PS.con;           PS.cint  = PS.int_;
	PS.cwis = PS.wis;           PS.cchr  = PS.chr;
      }
      prt_stat_block();
      break;

    case 12: 
      msg_print("You go momentarily insane.");
      for (i1 = 1; i1 <= 15; i1++) {
	move_char(8);     /*{make the player run in circles.}*/
	move_char(8);     /*{hee hee hee...           --jeb }*/
	move_char(9);  move_char(3);  move_char(2);
	move_char(2);  move_char(1);  move_char(1);
	move_char(randint(9));
      }
      break;

    case 13:
      msg_print("You completely lose your grip on reality."); 
      msg_print("");
      i3 = py.misc.lev;
      //with py.flags do;
      PF.image     = i3 + 100;
      PF.fast      = i3 + 50;
      PF.confused  = i3 + 10;
      PF.afraid    = i3 + 8;
      PF.blind     = i3 + 6;
      PF.poisoned  = i3 + 4;
      PF.paralysis = i3 + 0;
      break;
      
    case 14:
      msg_print("You suddenly remember your old nickname!");
      msg_print("");
      //with py.misc do;
      switch  (randint(16)) {
      case 1:  strcpy(PM.race, "Greedy");       break;
      case 2:  strcpy(PM.race, "Boring");       break;
      case 3:  strcpy(PM.race, "Wild");         break;
      case 4:  strcpy(PM.race, "Friendly");     break;
      case 5:  strcpy(PM.race, "Sleazy");       break;
      case 6:  strcpy(PM.race, "Lucky");        break;
      case 7:  strcpy(PM.race, "Muffin");       break;
      case 8:  strcpy(PM.race, "Foolish");      break;
      case 9:  strcpy(PM.race, "Party-Animal"); break;
      case 10: strcpy(PM.race, "Potato-Head");  break;
      case 11: strcpy(PM.race, "Dizzy");        break;
      case 12: strcpy(PM.race, "Unbearable");   break;
      case 13: strcpy(PM.race, "Pond Scum");    break;
      case 14: strcpy(PM.race, "Pizza-Face");   break;
      case 15: strcpy(PM.race, "Weiner");       break;
	msg_print("Oh I wish I was an Oscar Meyer Weiner...");
	break;
      case 16:
	if (!strcmp(py.misc.sex, "Female")) {
	  strcpy(PM.race, "Gorgeous");
	} else {
	  strcpy(PM.race, "Studly");
	}
	break;
      }
      break;

    case 15: 
      msg_print("Nickels from heaven!");
      for (i1 = 1; i1 <= (100*py.misc.lev); i1++) {
	py.misc.au += randint(3);
	prt_gold();
      }
      
    case 16:  /*{danny's goons}*/
      if (payment_count < 10) {
	was_wierd = false;
      } else {
	clear_from(1);
prt("Suddenly, from behind, a big pair of Danny Dollar's thugs",1,1);
prt("jump you!  \"Danny says yer behind on yer payments,\" the first",2,1);
prt("thug says.  \"Danny don't like late payments,\" his buddy says.",3,1);
prt("Then, the first thug pins your arms from behind, and blows",4,1);
prt("cigar smoke in your ear while the other slugs you in the gut",5,1);
prt("*really* hard, a lot of times.  They take all your money, and",6,1);
prt("leave you puking your guts out on the ground.",7,1);
	principal -= (py.misc.au div 2);
	if (principal <  0) { principal = 0; }
	if (principal == 0) { payment_count = 0; }
	py.misc.au   = 0;
	py.misc.chp /= 2;
	py.stat.con  = de_statp(py.stat.con);
	if (py.stat.ccon > py.stat.con) {
	  py.stat.ccon = py.stat.con;
	}
	py.flags.paralysis = 15;
	py.flags.food      = 250;
	pause_game(24);
	draw_cave();
      }
      break;
      
    case 17:
      if (dun_level < 1) {
	was_wierd = false;
      } else {
	msg_print("Suddenly, the earth rumbles...");
	msg_print("A giant hole opens underneath you!");
	make_light(char_row,char_col,5,false);/*{big dark hole around player}*/
	msg_print("It's a SINKHOLE!!!");
	msg_print("You are swirling around in the mud!");
	centery = char_row - panel_row_prt;
	centerx = char_col - panel_col_prt;
	y = centery;
	x = centerx;
	for (i1 = 1; i1 <= 360; i1++) {
	  put_buffer(" ",y,x);                 /*{ erase @ from the screen  }*/
	  r = 5.0 - (1.0*i1) / 72.0;           /*{ radius goes from 5 to 0  }*/
	  theta = (5.0*i1)/57.2957795;         /*{ 5 degree increments      }*/
	  y = centery + trunc(r*sin(theta));   /*{ some basic trig calcs.   }*/
	  x = centerx + trunc(1.4*r*cos(theta));
	  sleep(0);
	  put_buffer("@",y,x);                 /*{ put @ at new place       }*/
	  sleep(0);
	}
	put_buffer(" ",y,x); 
	dun_level = dun_level + randint(5);
	if (dun_level > townlist[town_num].max_depth) {
	  dun_level = townlist[town_num].max_depth;
	}
	moria_flag = true;                             /*{generate new level}*/
	msg_print("You land with a really hard thud.");
	take_hit(damroll("5d10"),"a sinkhole");
      }
      break;
      
    case 18:
      msg_print(" ");
      msg_print("You trip over a small rock, and discover");
      msg_print("some money lying underneath.");
      msg_print(" ");
      if (randint(100) > 5) {
	i1 = py.misc.lev * 5;
      } else {
	i1 = 1000+randint(1000);
      }
      py.misc.au += i1;
      msg_print("");                  
      prt_num("It's worth $",i1,1,1);
      prt_gold();
      break;
      
#ifdef DOOM_WORKS
    case 19:
      if (unleashed_doom) { /*Unleash doom code is still buggy -RLG)*/
	was_wierd = false;
      } else {
	unleashed_doom = true;
	msg_print("");
	msg_print("You hear a loud clap of thunder");
	msg_print("and a sickening feeling grows in your stomach.");
      }
      break;
#endif /* DOOM_WORKS */
      
      default:
      break;
    }
    
    wierd_type = 0;
  } while (! ((! force_wierd) || was_wierd));
  
  if ( !was_wierd ) {
    switch (randint(3)) {
    case 1: msg_print("You just avoided something strange.");   break;
    case 2: msg_print("That was a close call!");                break;
    case 3: msg_print("You are _sooo_ lucky!");                 break;
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/* END FILE wierd.c */
